#include <windows.h>
//#include <vcl\vcl.h>
#include <string.h>
#include <stdio.h>
#include <io.h>
#include "ese_general.h"
#include "ese_global.h"
#include "ese_common.h"


/* sql select֐wherep`FbN */
typedef struct {
	int tblno;
	int chkflg;
	long chknum;
	char* chkstr;
} esesql_select_where;



int esesql_select(char* buf);
int getarg_esesql_select( char* buf, char* target_column, char* table_name,char* where_column, char* order,int* start_push, int* end_push );
int get_table_file( char* table_name, char* db_file1, char* db_file2, char* entry_name1, char* entry_name2, char* key_column );
int read_esesql_select( char* db_name, char** db_buf, long* db_size );
int pickup_esesql_select( char* db_buf, char* db_entry, char* where_column, char* list[], long db_size, char* column_name );
int combine_pickup_esesql_select( char* db_buf, char* db_entry, char* where_column, char* list[], long db_size, char* column_name, char* list2[], char* column_name2, char* key_column );
int get_where_info( esesql_select_where* whereinfo, char* where_column );
int chk_where_info( esesql_select_where whereinfo[], char* buf );
int order_esesql_select( char* list[], char* order );
int chk_order_up( const void* list1, const void* list2 );
int chk_order_down( const void* list1, const void* list2 );
int get_order_info( char* order, int* order_info, int* order_tbl );
int gettbl_esesql_select( char* list[], char* target_column, int start_push, int end_push );
int change_clmname_to_no( char* moto, char* column_name );


extern void change_other_dic(int dic_no);
extern int get_response( char* input_buf, char* output_buf );
extern int remove_function(char* buf);

#define CHAR_SAKURA			1
#define CHAR_KERO			2

/************************************************************************/
/*				SQLselect										*/
/************************************************************************/
int esesql_select(char* buf)
{
	
	char* db_buf1;
	char** list1;
	char* db_buf2;
	char** list2;
	char target_column[1024];
	char table_name[1024];
	char where_column[1024];
	char order[32];
	char db_file1[1024];
	char db_file2[1024];
	char column_name1[1024];
	char column_name2[1024];
	char entry_name1[128];
	char entry_name2[128];
	char key_column[128];
	long db_buf1_size;
	long db_buf2_size;
	int start_push;
	int end_push;
	int loop_cnt;
	int table_cnt;
	
	/* 擾 */
	getarg_esesql_select(buf,target_column,table_name, where_column,order,&start_push,&end_push);
	
	/* Ώۃe[ut@CƃGgAL[J擾 */
	table_cnt = get_table_file( table_name, db_file1, db_file2, entry_name1, entry_name2, key_column );
	
	/* e[usǂŕ */
	if( table_cnt == 1 ){
		/* e[u̏ꍇ */
		/* t@CSēǂށiǂݍ݃obt@t@Cɍ킹ă擾j */
		read_esesql_select( db_file1, &db_buf1, &db_buf1_size );
		if( db_buf1 == NULL ){
			/* t@C or mۏoiُƂȂj */
			/* w肳ꂽPUSHGANA */
			for( loop_cnt = start_push; loop_cnt < end_push+1; loop_cnt++ ){
				free_target_paragraph( loop_cnt );
			}
			/* ֐ */
			remove_function( buf );
			return(0);
		}
		
		/* Xg쐬{ */
		list1 = (char**)malloc( sizeof(char*) * 8192 );
		if( list1 == NULL ){
			free(db_buf1);
			return(1);
		}
		for( loop_cnt = 0; loop_cnt < 8192; loop_cnt++ )*(list1+loop_cnt) = NULL;
		
		/* ɍ݂̂̂̃Xg쐬 */
		pickup_esesql_select( db_buf1, entry_name1, where_column, list1, db_buf1_size, column_name1 );
		
		/* J */
		free(db_buf1);
	}
	else{
		/* e[u̏ꍇi܂e[ǔKvj */
		/* ڂ̃t@CSēǂށiǂݍ݃obt@t@Cɍ킹ă擾j */
		read_esesql_select( db_file1, &db_buf1, &db_buf1_size );
		if( db_buf1 == NULL ){
			/* t@C or mۏoiُƂȂj */
			/* w肳ꂽPUSHGANA */
			for( loop_cnt = start_push; loop_cnt < end_push+1; loop_cnt++ ){
				free_target_paragraph( loop_cnt );
			}
			/* ֐ */
			remove_function( buf );
			return(0);
		}
		/* XgP쐬{ */
		list1 = (char**)malloc( sizeof(char*) * 8192 );
		if( list1 == NULL ){
			free(db_buf1);
			return(1);
		}
		for( loop_cnt = 0; loop_cnt < 8192; loop_cnt++ )*(list1+loop_cnt) = NULL;
		
		/* XgQ쐬{ */
		list2 = (char**)malloc( sizeof(char*) * 8192 );
		if( list2 == NULL ){
			free(list1);
			free(db_buf1);
			return(1);
		}
		for( loop_cnt = 0; loop_cnt < 8192; loop_cnt++ )*(list2+loop_cnt) = NULL;
		
		/* ڂ̃t@CSēǂށiǂݍ݃obt@t@Cɍ킹ă擾j */
		read_esesql_select( db_file2, &db_buf2, &db_buf2_size );
		if( db_buf2 == NULL ){
			/* t@C or mۏoQe[uڂɐɐi */
		}
		else{
			/* XgQ擾iwhere͖ɂj */
			pickup_esesql_select( db_buf2, entry_name2, "", list2, db_buf2_size, column_name2 );
		}
		
		/* Ȃɍ݂̂̂̃Xg쐬 */
		combine_pickup_esesql_select( db_buf1, entry_name1, where_column, list1, 
										db_buf1_size, column_name1, list2, column_name2, key_column );
		
		/* J */
		free(db_buf1);
		free(db_buf2);
		for( loop_cnt = 0; loop_cnt < 8192; loop_cnt++ ){
			if( *(list2+loop_cnt) != NULL )free(*(list2+loop_cnt));
		}
		free(list2);
	}
	
	/* 擾ΏۃJA\[gwJJԍ֕ϊ */
	change_clmname_to_no( target_column, column_name1 );
	change_clmname_to_no( order, column_name1 );
	
	/* \[g */
	order_esesql_select( list1, order );
	
	/* 擾ׂΏۃ^[QbgPUSHGAɃRs[ */
	gettbl_esesql_select( list1, target_column, start_push, end_push );
	
	/* ֐ */
	remove_function( buf );
	
	/* J */
	for( loop_cnt = 0; loop_cnt < 8192; loop_cnt++ ){
		if( *(list1+loop_cnt) != NULL )free(*(list1+loop_cnt));
	}
	free(list1);
	
	return(0);
}


/************************************************************************/
/*				SQLselectTui擾j					*/
/************************************************************************/
int getarg_esesql_select( char* buf, char* target_column, char* table_name,
						  char* where_column, char* order,
						  int* start_push, int* end_push )
{
	
	char* p_start;
	char* p_end;
	int word_len;
	int buf_len = strlen( buf );
	int arg_cnt = 0;
	int dq_flg = 0;
	int loop_cnt;
	
	/* 1byte */
	for( loop_cnt = 0; loop_cnt < buf_len; loop_cnt++ ){
		
		/* _uNH[gtꍇ */
		if( *(buf+loop_cnt) == '\"' ){
			/* Jñ_uNH[g̏ꍇ͈ʒuyъJn󋵂Ď̃oCg */
			if( dq_flg == 0 ){
				p_start = buf+loop_cnt+1;
				dq_flg = 1;
				continue;
			}
			/* Ĩ_uNH[g̏ꍇ͕擾 */
			else{
				dq_flg = 0;
				
				/* 񒷎擾 */
				p_end = buf+loop_cnt-1;
				word_len = p_end - p_start + 1;
				
				/* Ԗڂɏ]Ė߂lɃZbg */
				switch( arg_cnt ){
					case 0:
						/* P  擾ΏۃJ*/
						memcpy( target_column, p_start, word_len );
						target_column[word_len] = '\0';
						break;
					case 1:
						/* Q  e[uiGg{pXj*/
						memcpy( table_name, p_start, word_len );
						table_name[word_len] = '\0';
						break;
					case 2:
						/* R  擾e[u*/
						memcpy( where_column, p_start, word_len );
						where_column[word_len] = '\0';
						break;
					case 3:
						/* S  \[g*/
						memcpy( order, p_start, word_len );
						order[word_len] = '\0';
						break;
				}
			}
		}
		
		/* _uNH[gł͒g̃`FbNȂ */
		if( dq_flg == 1 )continue;
		
		/* J}tꍇ */
		if( *(buf+loop_cnt) == ',' ){
			/* ̔Ԗڂi߂ */
			arg_cnt++;
			
			/* ̔ԖڂSɂȂTAU擾ďI */
			if( arg_cnt == 4 ){
				sscanf( buf+loop_cnt, ", %ld , %ld", start_push, end_push );
				(*start_push)--;
				(*end_push)--;
				return(0);
			}
		}
	}
	
	/* ُIiȂ^Ȃꍇj */
	return(1);
	
}


/************************************************************************/
/*				SQLselectTuie[u𕪉j				*/
/************************************************************************/
int get_table_file( char* table_name, char* db_file1, char* db_file2, 
					char* entry_name1, char* entry_name2, char* key_column )
{
	
	char* start_point = table_name;
	char* now_point = table_name;
	int word_len = 0;
	int arg_cnt = 0;
	
	*db_file1 = *db_file2 = *entry_name1 = *entry_name2 = *key_column = '\0';
	
	while( *now_point != '\0' ){
		if( *(now_point+1) == '@' ){
			if( arg_cnt == 0 ){
				memcpy( entry_name1, start_point, word_len+1 );
				*(entry_name1 + word_len + 1 ) = '\0';
			}
			else{
				memcpy( entry_name2, start_point, word_len+1 );
				*(entry_name2 + word_len + 1 ) = '\0';
			}
			start_point = now_point+2;
			word_len = 0;
			now_point += 2;
			continue;
		}
		if( *(now_point+1) == ',' || *(now_point+1) == '\0' ){
			if( arg_cnt == 0 ){
				memcpy( db_file1, start_point, word_len+1 );
				*(db_file1 + word_len + 1 ) = '\0';
			}
			else if( arg_cnt == 1 ){
				memcpy( db_file2, start_point, word_len+1 );
				*(db_file2 + word_len + 1 ) = '\0';
			}
			else{
				if( memlcmp( start_point, "KYE=" ) != 0 &&
					memlcmp( start_point, "KEYCOLUMN=" ) != 0 ){
					*db_file2 = *entry_name2 = *key_column = '\0';
					arg_cnt = 1;
					break;
				}
				else{
					if( memlcmp( start_point, "KYE=" ) == 0 ){
						strcpy( key_column, start_point+4 );
					}
					else{
						strcpy( key_column, start_point+10 );
					}
					break;
				}
			}
			start_point = now_point+2;
			word_len = 0;
			now_point+=2;
			arg_cnt++;
			continue;
		}
		now_point++;
		word_len++;
	}
	
	return( arg_cnt );
	
}


/************************************************************************/
/*				SQLselectTuit@C[hj				*/
/************************************************************************/
int read_esesql_select( char* db_name, char** db_buf, long* db_size )
{
	FILE* fp;
	char db_path[1024];
	char* p_wrk;
	long size;
	
	*db_size = 0;
	
	/* t@C쐬 */
	strcpy( db_path, GlobalPath );
	strcat( db_path, db_name );
	
	/* t@CI[v */
	fp = fopen( db_path, "rb" );
	if( fp == NULL ){
		*db_buf = NULL;
		return(1);
	}
	
	/* t@C擾 */
	size = filelength( fileno( fp ) );
	*db_size = size+1;
	
	/* m */
	*db_buf = (char*)malloc(size+1);
	if( *db_buf == NULL ){
		fclose(fp);
		return(1);
	}
	
	/* t@Cǂݍ */
	p_wrk = *db_buf;
	while( size > 8192 ){
		fread( p_wrk, 8192, 1, fp );
		size-=8192;
		p_wrk+=8192;
	}
	fread( p_wrk, (int)size, 1, fp );
	
	/* t@CI[ɂdnesz肵\0t */
	*(p_wrk+size) = '\0';
	
	/* t@CN[Y */
	fclose(fp);
	
	return(0);
	
}


/************************************************************************/
/*				SQLselectTuiPsǂŃXg쐬j		*/
/************************************************************************/
int pickup_esesql_select( char* db_buf, char* db_entry, char* where_column, char* list[], long db_size, char* column_name )
{
	
	esesql_select_where whereinfo[30];
	char* p_now;
	char* p_wrk;
	int next_flg;
	int entry_flg = 0;
	int list_cnt = 0;
	int loop_cnt;
	int column_name_flg = 0;
	
	/* 擾[N */
	for( loop_cnt = 0; loop_cnt < 30; loop_cnt++ ){
		whereinfo[loop_cnt].chkflg = -1;
		whereinfo[loop_cnt].chknum = -1;
		whereinfo[loop_cnt].chkstr = NULL;
	}
	
	/* Ps`FbNJn */
	p_now = db_buf;
	for(; p_now < db_buf + db_size ;){
		/* Ys̉syщs̗L𔻒isꍇ͎̍s݂Ɣ肷j */
		for( p_wrk = p_now;; p_wrk++ ){
			if( *p_wrk == '\0' ){
				next_flg = 0;
				break;
			}
			if( *p_wrk == '\r' ){
				next_flg = 1;
				*p_wrk = '\0';
				break;
			}
			if( *p_wrk == '\n' ){
				next_flg = 1;
				*p_wrk = '\0';
				break;
			}
			if( *p_wrk == 0x1a ){
				next_flg = 0;
				*p_wrk = '\0';
				break;
			}
		}
		
		/* Rg */
		if( *p_now == '\0' ){
			if( next_flg == 0 )break;
			else{
				p_now++;
				continue;
			}
		}
		if( *p_now == '/' && *(p_now+1) == '/' ){
			if( next_flg == 0 )break;
			else{
				while( *p_now != '\0' )p_now++;
				p_now++;
				continue;
			}
		}
		
		/* Gg */
		if( *p_now == '#'){
			/* YGgǂmF */
			if( memlcmp( p_now+1, db_entry ) == 0 )entry_flg = 1;
			else								   entry_flg = 0;
			
			if( next_flg == 0 )break;
			else{
				while( *p_now != '\0' )p_now++;
				p_now++;
				continue;
			}
		}
		
		/* YGgÕf[^s */
		if( entry_flg == 0 ){
			if( next_flg == 0 )break;
			else{
				while( *p_now != '\0' )p_now++;
				p_now++;
				continue;
			}
		}
		
		/* J擾{where`FbNp擾 */
		if( column_name_flg == 0 ){
			if( memlcmp( p_now, "COLUMN_NAME=" ) == 0 ){
				strcpy( column_name, p_now+strlen("COLUMN_NAME=") );
				change_clmname_to_no( where_column, column_name );
				get_where_info( &whereinfo[0], where_column );
				column_name_flg = 1;
				while( *p_now != '\0' )p_now++;
				p_now++;
				continue;
			}
		}
		
		/* YGg̃f[^ */
		if( chk_where_info( &whereinfo[0], p_now ) == 0 ){
			p_wrk = (char*)malloc(strlen(p_now)+1);
			if( p_wrk == NULL )return(1);
			
			strcpy( p_wrk, p_now );
			list[list_cnt] = p_wrk;
			list_cnt++;
		}
		while( *p_now != '\0' )p_now++;
		p_now++;
		
	}
	
	return(0);
	
}


/************************************************************************/
/*			SQLselectTuiPsǂŃXg쐬{j	*/
/************************************************************************/
int combine_pickup_esesql_select( char* db_buf, char* db_entry, char* where_column, char* list[], 
long db_size, char* column_name, char* list2[], char* column_name2, char* key_column )
{
	
	esesql_select_where whereinfo[30];
	char** list2wrk;
	char* p_now;
	char* p_wrk;
	char wrk[1024];
	char wrk2[1024];
	int next_flg;
	int entry_flg = 0;
	int list_cnt = 0;
	int loop_cnt;
	int column_name_flg = 0;
	int key_column_no1;
	int key_column_no2;
	
	/* 擾[N */
	for( loop_cnt = 0; loop_cnt < 30; loop_cnt++ ){
		whereinfo[loop_cnt].chkflg = -1;
		whereinfo[loop_cnt].chknum = -1;
		whereinfo[loop_cnt].chkstr = NULL;
	}
	
	/* Ps`FbNJn */
	p_now = db_buf;
	for(; p_now < db_buf + db_size ;){
		/* Ys̉syщs̗L𔻒isꍇ͎̍s݂Ɣ肷j */
		for( p_wrk = p_now;; p_wrk++ ){
			if( *p_wrk == '\0' ){
				next_flg = 0;
				break;
			}
			if( *p_wrk == '\r' ){
				next_flg = 1;
				*p_wrk = '\0';
				break;
			}
			if( *p_wrk == '\n' ){
				next_flg = 1;
				*p_wrk = '\0';
				break;
			}
			if( *p_wrk == 0x1a ){
				next_flg = 0;
				*p_wrk = '\0';
				break;
			}
		}
		
		/* Rg */
		if( *p_now == '\0' ){
			if( next_flg == 0 )break;
			else{
				p_now++;
				continue;
			}
		}
		if( *p_now == '/' && *(p_now+1) == '/' ){
			if( next_flg == 0 )break;
			else{
				while( *p_now != '\0' )p_now++;
				p_now++;
				continue;
			}
		}
		
		/* Gg */
		if( *p_now == '#'){
			/* YGgǂmF */
			if( memlcmp( p_now+1, db_entry ) == 0 )entry_flg = 1;
			else								   entry_flg = 0;
			
			if( next_flg == 0 )break;
			else{
				while( *p_now != '\0' )p_now++;
				p_now++;
				continue;
			}
		}
		
		/* YGgÕf[^s */
		if( entry_flg == 0 ){
			if( next_flg == 0 )break;
			else{
				while( *p_now != '\0' )p_now++;
				p_now++;
				continue;
			}
		}
		
		/* J擾 */
		if( column_name_flg == 0 ){
			if( memlcmp( p_now, "COLUMN_NAME=" ) == 0 ){
				/* L[JJԍɕϊ */
				strcpy( wrk, key_column );
				change_clmname_to_no( wrk, p_now+strlen("COLUMN_NAME=") );
				if( sscanf( wrk, "TBL%d", &key_column_no1 ) != 1 )key_column_no1 = -1;
				strcpy( wrk, key_column );
				change_clmname_to_no( wrk, column_name2 );
				if( sscanf( wrk, "TBL%d", &key_column_no2 ) != 1 )key_column_no2 = -1;
				
				/* Pe[uƑQe[ũJ */
				strcpy( column_name, p_now+strlen("COLUMN_NAME=") );
				strcat( column_name, "," );
				strcat( column_name, column_name2 );
				change_clmname_to_no( where_column, column_name );
				
				/* where`FbNp擾 */
				get_where_info( &whereinfo[0], where_column );
				column_name_flg = 1;
				
				while( *p_now != '\0' )p_now++;
				p_now++;
				continue;
			}
		}
		
		/* ȍ~AYGg̃f[^ */
		
		/* L[Ɍ */
		if( key_column_no1 != -1 && key_column_no2 != -1 ){
			get_comma_word( p_now, wrk, key_column_no1-1 );
			list2wrk = list2;
			for( loop_cnt = 0; loop_cnt < 8192; loop_cnt++ ){
				if( list2wrk+loop_cnt == NULL ){
					strcpy( wrk, p_now );
					strcat( wrk, "," );
					strcat( wrk, list2wrk[0] );
					break;
				}
				get_comma_word( *(list2wrk+loop_cnt), wrk2, key_column_no2-1 );
				if( strcmp( wrk, wrk2 ) == 0 ){
					strcpy( wrk, p_now );
					strcat( wrk, "," );
					strcat( wrk, *(list2wrk+loop_cnt) );
					break;
				}
			}
		}
		else{
			strcpy( wrk, p_now );
		}
		
		/* where`FbNāÂo^ */
		if( chk_where_info( &whereinfo[0], wrk ) == 0 ){
			p_wrk = (char*)malloc(strlen(wrk)+1);
			if( p_wrk == NULL )return(1);
			
			strcpy( p_wrk, wrk );
			list[list_cnt] = p_wrk;
			list_cnt++;
		}
		while( *p_now != '\0' )p_now++;
		p_now++;
		
	}
	
	return(0);
	
}


/************************************************************************/
/*				SQLselectTuTuiwhere擾j				*/
/************************************************************************/
int get_where_info( esesql_select_where whereinfo[], char* where_column )
{
	
	char* p_wrk;
	char* p_wrk2;
	char* p_where;
	int loop_cnt;
	int where_cnt;
	int tbl_no;
	int chk_flg;
	long chk_num;
	
	/* 擾𐮗 */
	p_where = where_column;
	where_cnt = 0;
	while( (p_wrk2=strstr( p_where, "TBL" )) != NULL ){
		/* J}ŋ؂Ăꍇ̓J}𕶖ɂ */
		p_wrk = strchr( p_where, ',' );
		if( p_wrk != NULL )*p_wrk = '\0';
		
		/* Ώۃe[u擾 */
		tbl_no = 0;
		sscanf( p_wrk2, "TBL%02d", &tbl_no );
		if( tbl_no > 0 )tbl_no--;
		whereinfo[where_cnt].tblno = tbl_no;
		
		/* 擾 */
		p_wrk2+=5;
		while( *p_wrk2 == ' ' )p_wrk2++;
		
		if( *p_wrk2 == '>' && *(p_wrk2+1) == '=' )chk_flg = 1;
		else if( *p_wrk2 == '=' && *(p_wrk2+1) == '>' )chk_flg = 1;
		else if( *p_wrk2 == '<' && *(p_wrk2+1) == '=' )chk_flg = 2;
		else if( *p_wrk2 == '=' && *(p_wrk2+1) == '<' )chk_flg = 2;
		else if( *p_wrk2 == '>' && *(p_wrk2+1) == '<' )chk_flg = 3;
		else if( *p_wrk2 == '<' && *(p_wrk2+1) == '>' )chk_flg = 3;
		else if( *p_wrk2 == '>' )chk_flg = 4;
		else if( *p_wrk2 == '<' )chk_flg = 5;
		else if( *p_wrk2 == '=' )chk_flg = 6;
		whereinfo[where_cnt].chkflg = chk_flg;
		
		/* Ώێ擾i񂩂̔f܂ށj */
		p_wrk2 += ( chk_flg < 4 ? 2 : 1 );
		while( *p_wrk2 == ' ' )p_wrk2++;
		for( loop_cnt = 0; *(p_wrk2+loop_cnt) != '\0'; loop_cnt++ ){
			if( *(p_wrk2+loop_cnt) < '0' || *(p_wrk2+loop_cnt) > '9' )break;
		}
		if( *(p_wrk2+loop_cnt) == '\0'){
			/* Ƃď */
			sscanf( p_wrk2, "%ld", &chk_num );
			whereinfo[where_cnt].chknum = chk_num;
		}
		else{
			/* Ƃď */
			whereinfo[where_cnt].chkstr = p_wrk2;
		}
		
		where_cnt++;
		if( p_wrk != NULL )p_where = p_wrk+1;
		else			   p_where = p_where+1;
	}
	
	return(0);
	
}


/************************************************************************/
/*				SQLselectTuTuiwhere蔻fj			*/
/************************************************************************/
int chk_where_info( esesql_select_where whereinfo[], char* buf )
{
	
	char wrk[4096];
	char* p_wrk;
	char* p_now;
	long wrkl;
	int loop_cnt;
	int tbl_no = -1;
	int str_retcd;
	
	/* J}ɏ`FbN */
	strcpy( wrk, buf );
	p_now = wrk;
	for(;;){
		p_wrk = strchr( p_now, ',' );
		if( p_wrk != NULL )*p_wrk = '\0';
		tbl_no++;
		
		/* we[uɍ肷 */
		for( loop_cnt = 0; whereinfo[loop_cnt].chkflg != -1 || whereinfo[loop_cnt].chkstr != NULL; loop_cnt++ ){
			if( whereinfo[loop_cnt].tblno != tbl_no )continue;
			
			/* we[ȕt */
			if( whereinfo[loop_cnt].chknum != -1 ){
				/* Ƃă`FbNiȂꍇ͕svŔIj */
				if( sscanf( p_now, "%d", &wrkl ) != 1 )return(1);
				switch( whereinfo[loop_cnt].chkflg ){
					case 1:		/* >= */
						if( wrkl >= whereinfo[loop_cnt].chknum );else return(1);
						break;
					case 2:		/* <= */
						if( wrkl <= whereinfo[loop_cnt].chknum );else return(1);
						break;
					case 3:		/* >< */
						if( wrkl != whereinfo[loop_cnt].chknum );else return(1);
						break;
					case 4:		/* > */
						if( wrkl > whereinfo[loop_cnt].chknum );else return(1);
						break;
					case 5:		/* < */
						if( wrkl < whereinfo[loop_cnt].chknum );else return(1);
						break;
					case 6:		/* = */
						if( wrkl == whereinfo[loop_cnt].chknum );else return(1);
						break;
					default:
						/* ُIioOLj */
						return(1);
				}
			}
			else{
				/* Ƃă`FbN */
				str_retcd = strcmp( p_now, whereinfo[loop_cnt].chkstr );
				switch( whereinfo[loop_cnt].chkflg ){
					case 1:		/* >= */
						if( str_retcd >= 0 );else return(1);
						break;
					case 2:		/* <= */
						if( str_retcd <= 0 );else return(1);
						break;
					case 3:		/* >< */
						if( str_retcd != 0 );else return(1);
						break;
					case 4:		/* > */
						if( str_retcd > 0 );else return(1);
						break;
					case 5:		/* < */
						if( str_retcd < 0 );else return(1);
						break;
					case 6:		/* = */
						if( str_retcd == 0 );else return(1);
						break;
					default:
						/* ُIioOLj */
						return(1);
				}
				
			}
			
		}
		
		/* e[usĂΏIA܂cĂȂ玟̃e[u */
		if( p_wrk == NULL )return(0);
		else p_now = p_wrk+1;
		
	}
	
}


/************************************************************************/
/*				SQLselectTuiɂă\[gj		*/
/************************************************************************/
int GOrderTblNo;			//`FbNΏۂƂȂe[u
int order_esesql_select( char* list[], char* order )
{
	char **listwrk;
	unsigned long target;
	int order_info;
	int order_tbl;
	int list_num;
	int loop_cnt;
	int loop_cnt2;
	
	/* \[g擾 */
	get_order_info( order, &order_info, &order_tbl );
	
	/* \[gɏ]ă\[gs */
	switch( order_info ){
		case 1:			/* \[gȂ */
			return(0);
		case 2:			/* _ȏɂ */
			/* Xg̃f[^擾 */
			for( list_num = 0; list_num < 8192; list_num++ )if( list[list_num] == NULL )break;
			
			/* Xg̃Rs[쐬 */
			listwrk = (char**)malloc( sizeof(char*) * list_num );
			if( listwrk == NULL )return(0);
			memcpy( listwrk, list, sizeof(char*) * list_num );
			
			/* _Ɉڂウ */
			for( loop_cnt = 0; loop_cnt < list_num; loop_cnt++ ){
				/* Ώۂ_Ŏw */
				target = get_rnd_num( (unsigned long)(list_num-loop_cnt) );
				/* ΏۂTiɈڂÎ͔΂Kvj */
				for( loop_cnt2 = 0; loop_cnt2 < list_num; loop_cnt2++ ){
					if( listwrk[loop_cnt2] != NULL )target--;
					if( target == 0 ){
						/* ΏۂڂAڂIꏊɖڈt */
						list[loop_cnt] = listwrk[loop_cnt2];
						listwrk[loop_cnt2] = NULL;
						break;
					}
				}
			}
			free(listwrk);
			return(0);
			
		case 3:			/* Ƀ\[g */
			/* Xg̃f[^擾 */
			for( list_num = 0; list_num < 8192; list_num++ )if( list[list_num] == NULL )break;
			
			/* `FbNΏۃe[uZbg */
			GOrderTblNo = order_tbl;
			
			/* NCbN\[g| */
			qsort( (void*)list, list_num, sizeof(char*), chk_order_up );
			
			return(0);
			
		case 4:			/* ~Ƀ\[g */
			/* Xg̃f[^擾 */
			for( list_num = 0; list_num < 8192; list_num++ )if( list[list_num] == NULL )break;
			
			/* `FbNΏۃe[uZbg */
			GOrderTblNo = order_tbl;
			
			/* NCbN\[g| */
			qsort( (void*)list, list_num, sizeof(char*), chk_order_down );
			
			return(0);
			
	}
	
	/* ɂꍇُ͈I */
	return(1);
	
}


int chk_order_up( const void* list1, const void* list2 )
{
	
	char* p_list1;
	char* p_list2;
	long wrkl1;
	long wrkl2;
	int loop_cnt;
	int len1;
	int len2;
	int tbl_cnt;
	
	memcpy( (char*)&p_list1, list1, 4 );
	memcpy( (char*)&p_list2, list2, 4 );
	len1 = strlen(p_list1);
	len2 = strlen(p_list2);
	
	/* Ye[u擪擾iQe[uȍ~̏ꍇj */
	if( GOrderTblNo != 0 ){
		/* P̊Ye[ue擾 */
		for( loop_cnt = 0, tbl_cnt = 0; loop_cnt < len1; loop_cnt++, p_list1++ ){
			if( *p_list1 == ',' ){
				tbl_cnt++;
				if( tbl_cnt == GOrderTblNo ){
					p_list1++;
					break;
				}
			}
		}
		if( loop_cnt == len1 )p_list1 = NULL;
		
		/* Q̊Ye[ue擾 */
		for( loop_cnt = 0, tbl_cnt = 0; loop_cnt < len2; loop_cnt++, p_list2++ ){
			if( *p_list2 == ',' ){
				tbl_cnt++;
				if( tbl_cnt == GOrderTblNo ){
					p_list2++;
					break;
				}
			}
		}
		if( loop_cnt == len2 )p_list2 = NULL;
	}
	
	/* Ye[uꍇ */
	if( p_list1 == NULL && p_list2 == NULL )return(0);
	if( p_list1 == NULL )return(1);
	if( p_list2 == NULL )return(-1);
	
	/* 擪ɃXy[Xꍇ͔΂ */
	while( *p_list1 == ' ' )p_list1++;
	while( *p_list2 == ' ' )p_list2++;
	
	/* lꍇ͐lŔr */
	if( sscanf( p_list1, "%ld", &wrkl1 ) == 1 ){
		if( sscanf( p_list2, "%ld", &wrkl2 ) == 1 ){
			if( wrkl1 == wrkl2 )return(0);
			if( wrkl1 > wrkl2 )return(1);
			if( wrkl1 < wrkl2 )return(-1);
		}
	}
	
	/* PoCgr */
	for(;;p_list1++,p_list2++){
		if(  ( *p_list1 == '\0' || *p_list1 == ',' ) &&
			 ( *p_list2 == '\0' || *p_list2 == ',' ) )return(0);
		
		if( *p_list1 > *p_list2 )return(1);
		if( *p_list1 < *p_list2 )return(-1);
		
	}
	
}


int chk_order_down( const void* list1, const void* list2 )
{
	
	char* p_list1;
	char* p_list2;
	long wrkl1;
	long wrkl2;
	int loop_cnt;
	int len1;
	int len2;
	int tbl_cnt;
	
	memcpy( (char*)&p_list1, list1, 4 );
	memcpy( (char*)&p_list2, list2, 4 );
	len1 = strlen(p_list1);
	len2 = strlen(p_list2);
	
	/* Ye[u擪擾iQe[uȍ~̏ꍇj */
	if( GOrderTblNo != 0 ){
		/* P̊Ye[ue擾 */
		for( loop_cnt = 0, tbl_cnt = 0; loop_cnt < len1; loop_cnt++, p_list1++ ){
			if( *p_list1 == ',' ){
				tbl_cnt++;
				if( tbl_cnt == GOrderTblNo ){
					p_list1++;
					break;
				}
			}
		}
		if( loop_cnt == len1 )p_list1 = NULL;
		
		/* Q̊Ye[ue擾 */
		for( loop_cnt = 0, tbl_cnt = 0; loop_cnt < len2; loop_cnt++, p_list2++ ){
			if( *p_list2 == ',' ){
				tbl_cnt++;
				if( tbl_cnt == GOrderTblNo ){
					p_list2++;
					break;
				}
			}
		}
		if( loop_cnt == len2 )p_list2 = NULL;
	}
	
	/* Ye[uꍇ */
	if( p_list1 == NULL && p_list2 == NULL )return(0);
	if( p_list1 == NULL )return(1);
	if( p_list2 == NULL )return(-1);
	
	/* 擪ɃXy[Xꍇ͔΂ */
	while( *p_list1 == ' ' )p_list1++;
	while( *p_list2 == ' ' )p_list2++;
	
	/* lꍇ͐lŔr */
	if( sscanf( p_list1, "%ld", &wrkl1 ) == 1 ){
		if( sscanf( p_list2, "%ld", &wrkl2 ) == 1 ){
			if( wrkl1 == wrkl2 )return(0);
			if( wrkl1 < wrkl2 )return(1);
			if( wrkl1 > wrkl2 )return(-1);
		}
	}
	
	/* PoCgr */
	for(;;p_list1++,p_list2++){
		if(  ( *p_list1 == '\0' || *p_list1 == ',' ) &&
			 ( *p_list2 == '\0' || *p_list2 == ',' ) )return(0);
		
		if( *p_list1 < *p_list2 )return(1);
		if( *p_list1 > *p_list2 )return(-1);
		
	}
	
}


/************************************************************************/
/*				SQLselectTuTui\[g擾j			*/
/************************************************************************/
int get_order_info( char* order, int* order_info, int* order_tbl )
{
	
	char* p_wrk;
	
	*order_info = 0;
	if( memlcmp( order, "ORDER_NON" ) == 0 )*order_info = 1;			//\[giV
	else if( memlcmp( order, "ORDER_RANDOM" ) == 0 )*order_info = 2;	//_
	else if( memlcmp( order, "ORDER_UP" ) == 0 ){						//
		*order_info = 3;
		*order_tbl = 0;
		p_wrk = strstr( order, "TBL" );
		if( p_wrk != NULL )sscanf( p_wrk, "TBL%02d", order_tbl );
		if( *order_tbl > 0 )*order_tbl -= 1;
	}
	else if( memlcmp( order, "ORDER_DOWN" ) == 0 ){						//~
		*order_info = 4;
		*order_tbl = 0;
		p_wrk = strstr( order, "TBL" );
		if( p_wrk != NULL )sscanf( p_wrk, "TBL%02d", order_tbl );
		if( *order_tbl > 0 )*order_tbl -= 1;
	}
	else *order_info = 1;			//ȗ̓\[giVƔf
	
	return(0);
}


/************************************************************************/
/*			SQLselectTui擾f[^GAցj	*/
/************************************************************************/
#define TBL_TYPE_NORMAL	1
#define TBL_TYPE_SUM	2
#define DATANUM			3
int gettbl_esesql_select( char* list[], char* target_column, int start_push, int end_push )
{
	
	char* p_start;
	char* p_end;
	char* target_columnwrk = target_column;
	char* p_wrk;
	char wrk[64];
	long sum_wrk[50];
	long wrkl;
	int loop_cnt;
	int loop_cnt2;
	int loop_cnt3;
	int tbl_cnt;
	int target_columnno[50];
	int target_columntype[50];
	int wrki;
	int str_len;
	int list_cnt;
	int readtbl_num;
	int get_tbl_flg;
	
	/* 擾ׂe[u擾 */
	for(loop_cnt=0;loop_cnt<50;loop_cnt++){
		target_columnno[loop_cnt] = -1;
		target_columntype[loop_cnt] = -1;
	}
	for(loop_cnt=0;loop_cnt<50;loop_cnt++){
		
		if( sscanf( target_columnwrk, "TBL%02d", &wrki ) == 1 ){
			if( wrki > 0 )target_columnno[loop_cnt] = wrki - 1;
			target_columntype[loop_cnt] = TBL_TYPE_NORMAL;
			get_tbl_flg = TBL_TYPE_NORMAL;
		}
		else if( sscanf( target_columnwrk, "SUM_TBL%02d", &wrki ) == 1 ){
			if( wrki > 0 )target_columnno[loop_cnt] = wrki - 1;
			target_columntype[loop_cnt] = TBL_TYPE_SUM;
			get_tbl_flg = TBL_TYPE_SUM;
		}
		else if( memlcmp( target_columnwrk, "DATANUM" ) == 0 ){
			target_columnno[loop_cnt] = 0;
			target_columntype[loop_cnt] = DATANUM;
			get_tbl_flg = DATANUM;
		}
		
		p_wrk = strchr( target_columnwrk, ',' );
		if( p_wrk != NULL )target_columnwrk = p_wrk+1;
		else			   break;
	}
	readtbl_num = loop_cnt+1;
	
	/* ʏ̃e[u擾̏ꍇiPUSHŗ^ꂽj */
	if( get_tbl_flg == TBL_TYPE_NORMAL ){
		
		/* 擾f[^߁i擾f[^͎擾Ώۃe[u̔{łKvj */
		end_push -= (end_push-start_push+1) % readtbl_num;
		
		/* w肳ꂽPUSHꏊ̃e[uf[^擾 */
		list_cnt = 0;
		for( loop_cnt = start_push; loop_cnt < end_push+1; list_cnt++ ){
			
			for( loop_cnt3 = 0; loop_cnt3 < readtbl_num; loop_cnt++, loop_cnt3++ ){
				
				/* w肳ꂽf[^Ȃꍇ */
				if( list[list_cnt] == NULL ){
					str_len = 0;
				}
				
				/* 擪e[ȕꍇ */
				else if( target_columnno[loop_cnt3] == 0 ){
					p_start = list[list_cnt];
					p_end = strchr( p_start, ',' );
					if( p_end != NULL )str_len = p_end - p_start;
					else			   str_len = strlen( p_start );
				}
				/* 擪e[uł͂Ȃꍇ */
				else{
					for( loop_cnt2 = 0, tbl_cnt = 0;; loop_cnt2++ ){
						if( *(list[list_cnt]+loop_cnt2) == ',' ){
							tbl_cnt++;
							if( tbl_cnt == target_columnno[loop_cnt3] ){
								p_start = list[list_cnt]+loop_cnt2+1;
								p_end = strchr( p_start, ',' );
								if( p_end != NULL )str_len = p_end - p_start;
								else			   str_len = strlen( p_start );
								break;
							}
						}
						if( *(list[list_cnt]+loop_cnt2) == '\0' ){
							/* ΏۂƂȂe[u */
							str_len = 0;
							break;
						}
					}
				}
				
				/* mۂ */
				free_target_paragraph( loop_cnt );
				if( str_len == 0 ){
					/* OoCg̒̎̓mۂȂ */
				}
				else if( ( GStack[loop_cnt] = (char*)malloc( str_len+1 )) != NULL ){
					/* eRs[ */
					memcpy( GStack[loop_cnt], p_start, str_len );
					*(GStack[loop_cnt]+str_len) = '\0';
				}
				else{
					/* mێs */
					GStack[loop_cnt] = NULL;
					return(1);
				}
			}
		}
	}
	/* SUMnvZ̏ꍇiSe[uj */
	else{
		/* vZʃ[N */
		for( loop_cnt = 0; loop_cnt < 50; loop_cnt++ )sum_wrk[loop_cnt] = 0;
		
		/* Se[uf[^擾 */
		for( list_cnt = 0; list[list_cnt] != NULL; list_cnt++ ){
			
			for( loop_cnt3 = 0; loop_cnt3 < readtbl_num; loop_cnt3++ ){
				
				/* 擪e[ȕꍇ */
				if( target_columnno[loop_cnt3] == 0 ){
					p_start = list[list_cnt];
					p_end = strchr( p_start, ',' );
					if( p_end != NULL )str_len = p_end - p_start;
					else			   str_len = strlen( p_start );
				}
				/* 擪e[uł͂Ȃꍇ */
				else{
					for( loop_cnt2 = 0, tbl_cnt = 0;; loop_cnt2++ ){
						if( *(list[list_cnt]+loop_cnt2) == ',' ){
							tbl_cnt++;
							if( tbl_cnt == target_columnno[loop_cnt3] ){
								p_start = list[list_cnt]+loop_cnt2+1;
								p_end = strchr( p_start, ',' );
								if( p_end != NULL )str_len = p_end - p_start;
								else			   str_len = strlen( p_start );
								break;
							}
						}
						if( *(list[list_cnt]+loop_cnt2) == '\0' ){
							/* ΏۂƂȂe[u */
							str_len = 0;
							break;
						}
					}
				}
				
				/* SUM_TBL̏ꍇ͐lǂݎčv */
				if( target_columntype[loop_cnt3] == TBL_TYPE_SUM && str_len != 0){
					if( sscanf( p_start, "%ld", &wrkl ) == 1 ){
						sum_wrk[loop_cnt3] += wrkl;
					}
				}
				else if( target_columntype[loop_cnt3] == DATANUM ){
					sum_wrk[loop_cnt3]++;
				}
			}
		}
		
		/* 擾vZl𕶎ɂPUSHGAɊi[ */
		for( loop_cnt3 = 0, loop_cnt = start_push; loop_cnt < end_push+1; loop_cnt3++, loop_cnt++ ){
			sprintf(wrk,"%ld",sum_wrk[loop_cnt3] );
			str_len = strlen( wrk );
			
			/* mۂ */
			free_target_paragraph( loop_cnt );
			if( str_len == 0 ){
				/* OoCg̒̎̓mۂȂ */
			}
			else if( ( GStack[loop_cnt] = (char*)malloc( str_len+1 )) != NULL ){
				/* eRs[ */
				memcpy( GStack[loop_cnt], wrk, str_len );
				*(GStack[loop_cnt]+str_len) = '\0';
			}
			else{
				/* mێs */
				GStack[loop_cnt] = NULL;
				return(1);
			}
		}
	}
	
	return(0);
	
}


/************************************************************************/
/*			SQLselectRiJJԍ֒uj	*/
/************************************************************************/
int change_clmname_to_no( char* moto, char* column_name )
{
	
	char wrk[128];
	char* p_wrk;
	int loop_cnt;
	
	/* J̃J̐[v */
	for( loop_cnt = 0; ; loop_cnt++ ){
		/* YJ擾 */
		get_comma_word( column_name, wrk, loop_cnt );
		if( wrk[0] == '\0' )break;
		
		/* `FbN敶ɃJꍇ͒u */
		p_wrk = strstr( moto, wrk );
		if( p_wrk != NULL ){
			strmov( p_wrk+strlen(wrk), p_wrk + 5 );
			sprintf( wrk, "TBL%02d", loop_cnt+1 );
			memcpy( p_wrk, wrk, 5 );
		}
	}
	
	return(0);
	
}


