#include <windows.h>
//#include <vcl\vcl.h>
#include <string.h>
#include <stdio.h>
#include <io.h>
#include <time.h>
#include <mbstring.h>
#include <tlhelp32.h>
#include "ese_general.h"
#include "ese_global.h"
#include "ese_func.h"
#include "ese_common.h"

//USEUNIT("ese_common.cpp");
//USEUNIT("ese_func.cpp");
//USEUNIT("ese_db.cpp");
//---------------------------------------------------------------------------



int get_rnd_sentence( char* str_type, char* string );
int get_rnd_com_sentence( char* str_type_str, char* string, char* input );
int get_rnd_eseword( char* str_type_str, char* string );
int make_dokoitsu( char* buf, char* input_buf, int replace_flg );
unsigned long get_rnd_str( char* str_type, char* string, int* tag_len );
int getstr_from_nmlentry( char* tag_str, unsigned long* start_no, unsigned long* end_no, int* entry_str_len );
int get_select_style( char* entry, int tag_len );
int set_tagsel_flg( char str_type, unsigned long start_no, unsigned long end_no, int tagsel_flg );
unsigned long  get_sequetag_nowline( char str_type, unsigned long start_no, unsigned long end_no );
int set_select_no( char* entry, unsigned long select_no, int tag_len );
int get_entry_num( char* str_type_str );
int get_str_num( char str_type, unsigned long start_no, unsigned long end_no );
unsigned long get_str_ratio_total( char str_type, unsigned long start_no, unsigned long end_no );
unsigned long get_ap_str( char str_type, unsigned long start_no, unsigned long end_no, unsigned long target_num, char* string );
unsigned long get_ap_ratio( char str_type, unsigned long start_no, unsigned long end_no, unsigned long target_num, char* string );
int tag_exchange( char* moto, char* string, int tag_len );
void change_str_type( char* str_type_str );

int meta_to_char( char* buf );
int meta_to_metatemp( char* buf );
int metatemp_to_char( char* buf );
int metacnt_to_cnt( char* buf );
int delete_tabcode( char* buf );
int makoto_select( char* buf );
char* get_nonfunc_endpare( char* buf );
int chk_after_str( char* buf, char* str );
int multi_byte_chk( int c );
int chg_kata_to_hira( unsigned char* buf );



/************************************************************************/
/*				͂̂ǂ`								*/
/*				(ʏg[Nn)											*/
/************************************************************************/
int get_rnd_sentence( char* str_type_str , char* string )
{
	char* wrk;
	
	/* Ɨ̈m */
	wrk = (char*)malloc( LINE_BUF_SIZE );
	if( wrk == NULL )return(0);
	
	/* $MODEϊ */
	change_str_type( str_type_str );
	
	/* x[X擾 */
	int dummy;
	get_rnd_str( str_type_str, wrk, &dummy );
	
	/* ͌ߏi͕݂͑Ȃjj */
	int err_cnt;
	for( err_cnt = 0; err_cnt < 999; err_cnt++ ){
		if( make_dokoitsu( wrk, "", REPLACE_USE ) == 0 )break;
		
		/* IFŒeꂽ玟 */
		int dummy;
		get_rnd_str( str_type_str, wrk, &dummy );
	}
	if( err_cnt == 999 )strcpy( wrk, "ESESHIORI ERROR" );
	
	/* ߂lɌʂi[ */
	strcpy( string, wrk );
	
	free(wrk);
	return(0);
}


/************************************************************************/
/*				͂̂ǂ`								*/
/*				(COMMUNICATEg[Nn)									*/
/************************************************************************/
int get_rnd_com_sentence( char* str_type_str, char* string, char* input )
{
	char* wrk;
	int loop_cnt;
	int loop_cnt2;
	int err_cnt;
	unsigned long line;
	unsigned long retried_line[1000];		//͐オ""ꍇ̊̋Lꏊ
	
	/* Ɨ̈m */
	wrk = (char*)malloc( LINE_BUF_SIZE );
	if( wrk == NULL )return(0);
	
	/* $MODEϊ */
	change_str_type( str_type_str );

	/* YGg̃x[X擾 */
	unsigned long start_end_no = mem_to_ulong( str_type_str+2 );
	int str_num = get_str_num( *(str_type_str+1), start_end_no, start_end_no );
	
	/* x[X擾 */
	for( loop_cnt = 0; loop_cnt < str_num; loop_cnt++ ){
		/* ܂őI񂾎̖mI܂ŏoȂ */
		for( err_cnt = 0; err_cnt < 999; err_cnt++ ){
			/* ܂I */
			int dummy;
			line = get_rnd_str( str_type_str+1, wrk, &dummy );
			
			/* ܂őÎƔr */
			for( loop_cnt2 = 0; loop_cnt2 < loop_cnt; loop_cnt2++ ){
				if( line == retried_line[loop_cnt2] )break;		//̂imfj
			}
			if( loop_cnt2 == loop_cnt )break;		//S`FbNĂ̂̂łnj
		}
		/*  */
		if( make_dokoitsu( wrk, input, REPLACE_USE ) == 0 )break;
		
		/* _ꍇ͂̕gCɑI΂Ȃ悤ɂ */
		retried_line[loop_cnt] = line;
		
	}
	
	if( loop_cnt == str_num )strcpy( wrk, "ESESHIORI ERROR" );
	
	/* ߂li[ */
	strcpy( string, wrk );
	
	free(wrk);
	return(0);
}


/************************************************************************/
/*				͂Ȃǂ`						*/
/*				(getword,getdmsn)										*/
/************************************************************************/
int get_rnd_eseword( char* str_type_str, char* string )
{
	char* wrk;
	int err_cnt;
	
	/* Ɨ̈m */
	wrk = (char*)malloc( LINE_BUF_SIZE );
	if( wrk == NULL )return(0);
	
	/* $MODEϊ */
	change_str_type( str_type_str );

	for( err_cnt = 0; err_cnt < 999; err_cnt++ ){
		/* x[X擾 */
		int dummy;
		get_rnd_str( str_type_str+1, wrk, &dummy );
		
		/* ߁i͕͖͂j */
		if( make_dokoitsu( wrk, "", REPLACE_NOT_USE ) == 0 )break;
	}
	if( err_cnt == 999 )strcpy( wrk, "ESESHIORI ERROR.\\e" );
	
	/* ߂lZbg */
	strcpy( string, wrk );
	
	free(wrk);
	return(0);
}


/************************************************************************/
/*				ǂ`Tu											*/
/************************************************************************/
int make_dokoitsu( char* buf, char* input_buf, int replace_flg )
{
	
	char* wrk;
	
	/* Ɨ̈m */
	wrk = (char*)malloc( LINE_BUF_SIZE );
	if( wrk == NULL )return(0);
	
	/* COMMUNICATEnϐ */
	GSendGhostName[0] = '\0';
	GSendAge = 0;
	
	/* ^ꎞu */
	meta_to_metatemp( buf );
	
	/* ^uR[h폜 */
	delete_tabcode( buf );
	
	/* t@NVni$??jiOij */
	log_write_user( "--first--------------------------", "ese_fncanl.log", GDBGFncAnalysis );
	int retry = act_func( buf, input_buf, 1 );
	if( retry != 0 ){
		free(wrk);
		return(retry);
	}
	log_write_user( "++++", "ese_fncanl.log", GDBGFncAnalysis );
	log_write_user( buf, "ese_fncanl.log", GDBGFncAnalysis );
	log_write_user( "--first end----------------------", "ese_fncanl.log", GDBGFncAnalysis );
	
	/*  */
	char* p_wrk;
	int loop_cnt;
	int error_cnt = 0;
	unsigned long line;
	while( ( p_wrk = strchr( buf, '%' ) ) != NULL ){
		/* [vh~p */
		error_cnt++;
		if( error_cnt >= 999 )break;
		
		/* ŗL^O */
		if( GStrName != NULL ){
			for( loop_cnt = 0; loop_cnt < GStrNameNum; loop_cnt++ ){
				if( !memcmp( GStrName[loop_cnt].tag, p_wrk+1, strlen(GStrName[loop_cnt].tag) ) ){
					/* YŗLu */
					tag_exchange( p_wrk, GStrName[loop_cnt].string, strlen(GStrName[loop_cnt].tag) );
					break;
				}
			}
			if( loop_cnt < GStrNameNum )continue;		//[vru
		}
		
		/* "%"ꍇ͊o̒P𓖂Ă͂߂ */
		if( isdigit( *(p_wrk+1) ) ){
			int wrkl = 0;
			sscanf( p_wrk+1, "%05ld", &wrkl );
			if( wrkl > 999 )wrkl = 0;	//傫߂B
			tag_exchange( p_wrk, (GAiDic+GStrMemory[wrkl])->string, 5 );
		}
		else{
			/* ʏ̒u */
			char wrkc;
			int replace_flg_wrk;
			if( *(p_wrk+1) == '_' ){
				/* ĒuΏۂƂȂ */
				wrkc = *(p_wrk+2);
				replace_flg_wrk = REPLACE_NOT_USE;
			}
			else if( *(p_wrk+1) == '!' ){
				/* ĒuGANA */
				wrkc = *(p_wrk+2);
				replace_flg_wrk = REPLACE_CLEAR;
			}
			else{
				/* ĒuΏۂƂ */
				wrkc = *(p_wrk+1);
				replace_flg_wrk = REPLACE_USE;
			}
			int tag_len;
			
			if( replace_flg_wrk == REPLACE_USE ){
				line = get_rnd_str( p_wrk+1, wrk, &tag_len );	//YP擾
				tag_exchange( p_wrk, wrk, tag_len );			//u
			}
			else{
				get_rnd_str( p_wrk+2, wrk, &tag_len );			//YP擾
				tag_exchange( p_wrk, wrk, tag_len+1 );			//u
			}
			
			/* u͂łȂŏقȂ */
			if( wrkc != 's' && replace_flg == REPLACE_USE && 
							   replace_flg_wrk == REPLACE_USE ){
				/* uɎgpPCŋL */
				if( GStrMemCnt < 1000 ){
					GStrMemory[GStrMemCnt] = line;
					GStrMemCnt++;
				}
			}
			else if( replace_flg_wrk == REPLACE_NOT_USE ){
				/* ĒuȂ^O͋LȂ */
			}
			else{
				/* Pꗚ */
				GStrMemCnt = 0;
				memset( GStrMemory, 0, sizeof(int)*889 );
			}
		}
		
		/* ^͒uɒuKv */
		meta_to_metatemp( buf );
		
		/* s֐uɎs */
		if( strstr( buf, "$_" ) != NULL ){
			log_write_user( "--second-------------------------", "ese_fncanl.log", GDBGFncAnalysis );
			int retry = act_func( buf, input_buf, 1 );
			if( retry != 0 ){
				free(wrk);
				return(retry);
			}
		}
		
	}
	
	/* ^uR[h폜 */
	delete_tabcode( buf );
	
	/* Ammakoto.dllƓI */
	makoto_select( buf );
	
	/* ^ꎞu𕜋A */
	metatemp_to_char( buf );
	
	/* t@NVni$??jiŏIij */
	log_write_user( "--third--------------------------", "ese_fncanl.log", GDBGFncAnalysis );
	retry = act_func( buf, input_buf, 0 );
	log_write_user( "--all end------------------------", "ese_fncanl.log", GDBGFncAnalysis );
	
	/* PꗚNA */
	GStrMemCnt = 0;
	memset( GStrMemory, 0, sizeof(int)*889 );
	
	free(wrk);
	return(retry);
	
}


/************************************************************************/
/*				w肳ꂽ^CvE͈͂ł̕񃉃_擾			*/
/*				iqc[͎ėȂj								*/
/************************************************************************/
unsigned long get_rnd_str( char* str_type_str , char* string, int* tag_len )
{
	
	unsigned long start_no;
	unsigned long end_no;
	unsigned long line;
	int flg = 0;
	
	/* ʏGgCOMMUNICATEn؂蕪 */
	if( *str_type_str == '#' ){
		/*COMMUNICATEnGg */
		start_no = end_no = mem_to_ulong( str_type_str+1 );
	}
	else{
		/* ʏGg */
		if( getstr_from_nmlentry( str_type_str, &start_no, &end_no, tag_len ) != 0 ){
			/* ݂ȂGg^Ow肳ꂽꍇ */
			char error_out[128];
			*tag_len = 0;
			if( GTagSerErrOut == 0 ){
				/* ڃG[o */
				sprintf( string, "ESESHIORI ERROR(%c,%lx-%lx)", *str_type_str, start_no, end_no );
			}
			else if( GTagSerErrOut == 1 ){
				/* OɃG[o */
				*string = '\0';
				sprintf( error_out, "ESESHIORI ERROR(%c,%lx-%lx)", *str_type_str, start_no, end_no );
				log_write_user( error_out, "eseai_tagsel_err.log", 1 );
			}
			else{
				/* G[o͂Ȃ */
				*string = '\0';
			}
			return(0);
		}
		
		/* I@擾 */
		if( *str_type_str != '#' )flg = get_select_style( str_type_str, *tag_len );
		
		/* I@ǂ݂ꍇ́A݈ʒu̕擾A݈ʒuIς݂ɂďI */
		if( flg == 1 ){
			/* ݈ʒu擾 */
			line = get_sequetag_nowline( *str_type_str, start_no, end_no );
			
			/* Y擾 */
			strcpy( string, (GAiDic + line)->string );
			
			/* ݈ʒuIς݂ɂ */
			(GAiDic+line)->tag_sel_flg = TAGSEL_DONE;
			
			/* SđIIꍇ̓tO */
			if( get_str_ratio_total( *str_type_str, start_no, end_no ) == 0 ){
				set_tagsel_flg( *str_type_str, start_no, end_no, TAGSEL_OK );
			}
			
			return(line);
		}
		
	}
	
	/* w肳ꂽ^Cv̏̕ov擾 */
	unsigned long str_num = get_str_ratio_total( *str_type_str, start_no, end_no );
	
	/* ov烉_Ŏwlo */
	unsigned long target_num = get_rnd_num( str_num );
	
	/* _lȂĕ擾 */
	line = get_ap_ratio( *str_type_str, start_no, end_no, target_num, string );
	
	/* I@SIꍇ͑If[^Iςɂ */
	if( flg == 2 ){
		(GAiDic+line)->tag_sel_flg = TAGSEL_DONE;
		
		/* SđIIꍇ̓tO */
		if( get_str_ratio_total( *str_type_str, start_no, end_no ) == 0 ){
			set_tagsel_flg( *str_type_str, start_no, end_no, TAGSEL_OK );
		}
	}
	
	return(line);
}

/************************************************************************/
/*				ʏGge[uƃ^O˂킹ă`FbN	*/
/************************************************************************/
int getstr_from_nmlentry( char* tag_str, unsigned long* start_no, unsigned long* end_no, int* entry_str_len )
{
	
	StrEntryList* entry_list_wrk = GEntryList;
	int now_point;
	char* entstr;
	
	/* 擪PoCg`FbN */
	now_point = 0;
	entstr = entry_list_wrk->string;
	for(;;){
		/* PoCgvꍇ */
		if( *(entstr + now_point) == *(tag_str + now_point) ){
			/* Gg񂪏Iꍇ͈vƌ */
			if( *(entstr + now_point + 1) == '\0' ){
				*start_no = entry_list_wrk->start_no;
				*end_no = entry_list_wrk->end_no;
				*entry_str_len = strlen( entry_list_wrk->string );
				return(0);
			}
			/* Ggɑꍇ͎̂PoCg */
			else{
				now_point++;
				continue;
			}
		}
		/* vAȂGg񂪏Iꍇ */
		else if( *(entstr + now_point) == '*' ){
			/* `FbNʒuPoCg߂ */
			now_point--;
			if( now_point == 0 ){
				return(-1);
			}
		}
		
		/* ΏۃGĝ̂ɕς */
		entry_list_wrk++;
		if( entry_list_wrk->start_no == -1 ){
			return(-1);
		}
		else{
			entstr = entry_list_wrk->string;
		}
	}
	
}


/************************************************************************/
/*				w肳ꂽʏGg̒u@擾				*/
/************************************************************************/
int get_select_style( char* entry, int tag_len )
{
	
	unsigned long select_style = 0L;
	
	/* YGgTđI^CvAIʒu擾 */
	unsigned long loop_cnt;
	StrDicPnt* p_ai_dic = GAiDic;
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++, p_ai_dic++ ){
		if( p_ai_dic->entry_type != ' ' )continue;
		if( memcmp( p_ai_dic->string+1, entry, tag_len )!=0 )continue;
		
		/* YGgȂ̂ŒlZbgă[vI */
		select_style = p_ai_dic->tag_sel_style;
		break;
	}
	
	return( select_style );
	
}


/************************************************************************/
/*		w肳ꂽʏGg̊ef[^sutOZbg		*/
/************************************************************************/
int set_tagsel_flg( char str_type, unsigned long start_no, unsigned long end_no, int tagsel_flg )
{
	StrDicPnt* p_ai_dic = GAiDic;
	unsigned long loop_cnt;
	
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
		/* wGgɑ邩ǂ`FbN */
		if( (p_ai_dic+loop_cnt)->entry_type == str_type &&
			(p_ai_dic+loop_cnt)->entry_no   >= start_no &&
			(p_ai_dic+loop_cnt)->entry_no   <= end_no){
			
			/* ۑIf[^͂Ƃ΂ */
			if( (p_ai_dic+loop_cnt)->tag_sel_flg == TAGSEL_NO )continue;
			
			/* Yf[^ɒlZbg */
			(p_ai_dic+loop_cnt)->tag_sel_flg = tagsel_flg;
			
		}
	}
	
	return(0);
}


/************************************************************************/
/*		^OǂݎAݓǂނׂf[^̈ʒu擾				*/
/************************************************************************/
unsigned long  get_sequetag_nowline( char str_type, unsigned long start_no, unsigned long end_no )
{
	StrDicPnt* p_ai_dic = GAiDic;
	unsigned long loop_cnt;
	unsigned long start_point = 0xffffffff;
	
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
		/* wGgɑ邩ǂ`FbN */
		if( (p_ai_dic+loop_cnt)->entry_type == str_type &&
			(p_ai_dic+loop_cnt)->entry_no   >= start_no &&
			(p_ai_dic+loop_cnt)->entry_no   <= end_no){
			
			/* wGgŏ̃f[^LĂ */
			if( start_point == 0xffffffff )start_point = loop_cnt;
			
			/* ŏɌnjf[^̈ʒuԂ */
			if( (p_ai_dic+loop_cnt)->tag_sel_flg == TAGSEL_OK ){
				return(loop_cnt);
			}
			
		}
	}
	
	/* njȂ̂ŎwGgŏ̃f[^ʒuԂ */
	return(start_point);
}


/************************************************************************/
/*				w肳ꂽʏGg̑IʒuXV				*/
/************************************************************************/
int set_select_no( char* entry, unsigned long select_no, int tag_len )
{
	
	/* YGgTđIʒuXV */
	unsigned long loop_cnt;
	StrDicPnt* p_ai_dic = GAiDic;
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++, p_ai_dic++ ){
		if( p_ai_dic->entry_type != ' ' )continue;
		if( memcmp( p_ai_dic->string+1, entry, tag_len )!=0 )continue;
		
		/* YGgȂ̂ŒlXVă[vI */
		p_ai_dic->ratio = select_no;
		break;
	}
	
	return( 0 );
	
}


/************************************************************************/
/*				w肳ꂽʏGgɑf[^擾		*/
/************************************************************************/
int get_entry_num( char* str_type_str )
{

	
	unsigned long start_no;
	unsigned long end_no;
	int dummy;
	
	if( *str_type_str == 0 )return(0L);
	
	if( getstr_from_nmlentry( str_type_str, &start_no, &end_no, &dummy ) != 0 )return(0L);
	
	/* w肳ꂽGg̃f[^擾 */
	return( get_str_num( *str_type_str, start_no, end_no ) );
}


/************************************************************************/
/*				w肳ꂽ񐔂̎擾								*/
/************************************************************************/
int get_str_num( char str_type, unsigned long start_no, unsigned long end_no )
{
	StrDicPnt* p_ai_dic = GAiDic;
	unsigned long loop_cnt;
	int target_num = 0;
	
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
		/* wGgɑ邩ǂ`FbN */
		if( (p_ai_dic+loop_cnt)->entry_type == str_type &&
			(p_ai_dic+loop_cnt)->entry_no   >= start_no &&
			(p_ai_dic+loop_cnt)->entry_no   <= end_no){
			
			/* ۑIf[^͂Ƃ΂ */
			if( (p_ai_dic+loop_cnt)->tag_sel_flg != TAGSEL_OK )continue;
			
			target_num++;
		}
	}
	
	return(target_num);
}

/************************************************************************/
/*				w肳ꂽ̏ov擾						*/
/************************************************************************/
unsigned long get_str_ratio_total( char str_type, unsigned long start_no, unsigned long end_no )
{
	StrDicPnt* p_ai_dic = GAiDic;
	unsigned long loop_cnt;
	int target_num = 0;
	
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
		/* wGgɑ邩ǂ`FbN */
		if( (p_ai_dic+loop_cnt)->entry_type == str_type &&
			(p_ai_dic+loop_cnt)->entry_no   >= start_no &&
			(p_ai_dic+loop_cnt)->entry_no   <= end_no ){
			
			/* ۑIf[^͂Ƃ΂ */
			if( (p_ai_dic+loop_cnt)->tag_sel_flg != TAGSEL_OK )continue;
			
			/* wGgŎqc[ł͂Ȃ̂ŏo𑫂Ă */
			target_num+=(p_ai_dic+loop_cnt)->ratio;
		}
	}
	
	return(target_num);
}

/************************************************************************/
/*				w肳ꂽ̎擾									*/
/************************************************************************/
unsigned long get_ap_str( char str_type, unsigned long start_no, unsigned long end_no, unsigned long target_num, char* string )
{
	StrDicPnt* p_ai_dic = GAiDic;
	unsigned long loop_cnt;
	char error_out[128];
	
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
		/* wGgɑ邩ǂ`FbN */
		if( (p_ai_dic+loop_cnt)->entry_type == str_type &&
			(p_ai_dic+loop_cnt)->entry_no   >= start_no &&
			(p_ai_dic+loop_cnt)->entry_no   <= end_no ){
			
			/* ۑIf[^͂Ƃ΂ */
			if( (p_ai_dic+loop_cnt)->tag_sel_flg != TAGSEL_OK )continue;
			
			/* wGgȂ̂ŊY邩ǂ`FbN */
			if( target_num == 0 ){
				strcpy( string, (p_ai_dic+loop_cnt)->string );
				return(loop_cnt);			//߂l͏ォ牽Cڂɂ̃C
			}
			else{
				target_num--;
			}
		}
	}
	
	/* ɗꍇ̓G[̔ */
	if( GTagSerErrOut == 0 ){
		/* ڃG[o */
		sprintf( string, "ESESHIORI ERROR(%c,%lx-%lx)", str_type, start_no, end_no );
	}
	else if( GTagSerErrOut == 1 ){
		/* OɃG[o */
		*string = '\0';
		sprintf( error_out, "ESESHIORI ERROR(%c,%lx-%lx)", str_type, start_no, end_no );
		log_write_user( error_out, "eseai_tagsel_err.log", 1 );
	}
	else{
		/* G[o͂Ȃ */
		*string = '\0';
	}
	
	return(0);
}


/************************************************************************/
/*				w肳ꂽ̎擾ioŎwj					*/
/************************************************************************/
unsigned long get_ap_ratio( char str_type, unsigned long start_no, unsigned long end_no, unsigned long target_num, char* string )
{
	StrDicPnt* p_ai_dic = GAiDic;
	unsigned long loop_cnt;
	char error_out[128];
	
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
		/* wGgɑ邩ǂ`FbN */
		if( (p_ai_dic+loop_cnt)->entry_type == str_type &&
			(p_ai_dic+loop_cnt)->entry_no   >= start_no &&
			(p_ai_dic+loop_cnt)->entry_no   <= end_no ){
			
			/* ۑIf[^͂Ƃ΂ */
			if( (p_ai_dic+loop_cnt)->tag_sel_flg != TAGSEL_OK )continue;
			
			/* wGgȂ̂ŏoY邩ǂ`FbN */
			if( target_num <= (p_ai_dic+loop_cnt)->ratio ){
				strcpy( string, (p_ai_dic+loop_cnt)->string );
				return(loop_cnt);			//߂l͏ォ牽Cڂɂ̃C
			}
			else{
				target_num-=(p_ai_dic+loop_cnt)->ratio;
			}
		}
	}
	
	/* ɗꍇ̓G[̔ */
	if( GTagSerErrOut == 0 ){
		/* ڃG[o */
		sprintf( string, "ESESHIORI ERROR(%c,%lx-%lx)", str_type, start_no, end_no );
	}
	else if( GTagSerErrOut == 1 ){
		/* OɃG[o */
		*string = '\0';
		sprintf( error_out, "ESESHIORI ERROR(%c,%lx-%lx)", str_type, start_no, end_no );
		log_write_user( error_out, "eseai_tagsel_err.log", 1 );
	}
	else{
		/* G[o͂Ȃ */
		*string = '\0';
	}
	
	return(0);
}


/************************************************************************/
/* 			woCg̃^Ou									*/
/************************************************************************/
int tag_exchange( char* moto, char* string, int tag_len )
{
	int loop_cnt;
	int len = strlen( moto );
	
	/* ^ÕAX^XŇ𐔂îŁj */
	for( loop_cnt = 0; loop_cnt < len; loop_cnt++ ){
		if( *(moto+tag_len+1+loop_cnt) != '*' )break;
	}
	
	/* Zbgׂnull|C^ł͂Ȃǂ */
	if( string != NULL ){
		/* ʏ폈 */
		/* ^Oɂ镶̈ʒu𒲐 */
		strmov( moto + tag_len + loop_cnt + 1, moto + strlen(string) );
		
		/* uׂYꏊɏ */
		memcpy( moto, string, strlen(string) );
	}
	else{
		/* null|C^̂Ń^Ȍ̂ݍsȂ */
		strmov( moto + tag_len + loop_cnt + 1, moto );
	}
	
	return(0);
}

/************************************************************************/
/* 			$MODEϊi"sr1**"w肳Ăʂ̂̂Ɂj				*/
/************************************************************************/
void change_str_type( char* str_type_str )
{
	if( *str_type_str != 's' )return;
	if( *(str_type_str+1) != 'r' )return;
	if( *(str_type_str+2) != '1' )return;

	strcpy( str_type_str, GRndEntry );
}


/************************************************************************/
/* 			񒆂̃^ʏ̌`ɂ							*/
/************************************************************************/
int meta_to_char( char* buf )
{
	char* p_wrk;
	
	while( ( p_wrk = strstr( buf, "%%" ) ) != NULL ){
		strmov( p_wrk+1, p_wrk );
	}
	
	while( ( p_wrk = strstr( buf, "%(" ) ) != NULL ){
		strmov( p_wrk+1, p_wrk );
	}
	
	while( ( p_wrk = strstr( buf, "%)" ) ) != NULL ){
		strmov( p_wrk+1, p_wrk );
	}
	
	return(0);
	
}

/************************************************************************/
/* 			񒆂̃^ꎞu						*/
/************************************************************************/
int meta_to_metatemp( char* buf )
{
	char* p_wrk;
	
	while( ( p_wrk = strstr( buf, "%%" ) ) != NULL )memcpy( p_wrk, "\1\2", 2 );
	while( ( p_wrk = strstr( buf, "%(" ) ) != NULL )memcpy( p_wrk, "\1\3", 2 );
	while( ( p_wrk = strstr( buf, "%)" ) ) != NULL )memcpy( p_wrk, "\1\4", 2 );
	while( ( p_wrk = strstr( buf, "%&" ) ) != NULL )memcpy( p_wrk, "\1\5", 2 );
	
	return(0);
	
}

/************************************************************************/
/* 			񒆂̃^ꎞu߂						*/
/************************************************************************/
int metatemp_to_char( char* buf )
{
	
	char* p_wrk;
	char wrk[3];
	char wrkc;
	
	while( ( p_wrk = strstr( buf, "\1\2" ) ) != NULL ){
		strmov( p_wrk+2, p_wrk+1 );
		*p_wrk = '%';
	}
	while( ( p_wrk = strstr( buf, "\1\3" ) ) != NULL ){
		strmov( p_wrk+2, p_wrk+1 );
		*p_wrk = '(';
	}
	while( ( p_wrk = strstr( buf, "\1\4" ) ) != NULL ){
		strmov( p_wrk+2, p_wrk+1 );
		*p_wrk = ')';
	}
	
	while( ( p_wrk = strstr( buf, "\1\5" ) ) != NULL ){
		memcpy( wrk, p_wrk+2, 2 );
		wrk[2] = '\0';
		sscanf( wrk, "%02x", &wrkc );
		sprintf( wrk, "%c", wrkc );
		strmov( p_wrk+4, p_wrk+1 );
		*p_wrk = wrk[0];
	}
	
	return(0);
	
}


/************************************************************************/
/* 			^䕶ϊ										*/
/************************************************************************/
int metacnt_to_cnt( char* buf )
{
	
	char wrk[3];
	char wrkc;
	char* p_wrk;
	
	while( ( p_wrk = strstr( buf, "%&" ) ) != NULL ){
		memcpy( wrk, p_wrk+2, 2 );
		wrk[2] = '\0';
		sscanf( wrk, "%02x", &wrkc );
		sprintf( wrk, "%c", wrkc );
		strmov( p_wrk+4, p_wrk+1 );
		*p_wrk = wrk[0];
	}
	
	return(0);
	
}


/************************************************************************/
/* 			񒆂̃^uR[h								*/
/************************************************************************/
int delete_tabcode( char* buf )
{
	
	char* p_wrk;
	
	while( ( p_wrk = strchr( buf, 0x09 ) ) != NULL ){
		strmov( p_wrk+1, p_wrk );
	}
	
	return(0);
	
}


/************************************************************************/
/* 			gmakoto.dllقڌ݊is[g͓ĂȂj			*/
/* 	iJꂽ\[XQlɂ܂BłOsȂłDDDj*/
/* 	iɎӎ\v܂BL܂					  j*/
/************************************************************************/
int makoto_select( char* buf )
{
	char* p_wrk;
	char* p_start_pare;
	char* p_end_pare;
	char wrk[4096];
	int pare_cnt;
	int loop_cnt;
	int loop_max;
	unsigned long ratio;
	unsigned long ratio_total;
	
	/* ֐ł͂ȂۊʂȂ܂ŏsȂ */
	while( ( p_wrk = get_nonfunc_endpare( buf ) ) != NULL ){
		
		/* ov */
		ratio_total = 0;
		
		/* ۊʕT */
		loop_max = strlen(p_wrk);
		p_start_pare = p_wrk;
		pare_cnt = 1;
		for( loop_cnt = 1; loop_cnt < loop_max; loop_cnt++ ){
			if( *(p_start_pare+loop_cnt) == '(' )pare_cnt++;
			if( *(p_start_pare+loop_cnt) == ')' )pare_cnt--;
			if( pare_cnt == 0 )break;
		}
		if( loop_cnt == loop_max ){
			/* G[iρj */
			return(1);
		}
		
		/* ʕʒuLĊʂ̒g[NɃRs[ */
		p_end_pare = p_start_pare+loop_cnt;
		if( loop_cnt-1 < 4090 ){
			memcpy( wrk, p_wrk+1, loop_cnt-1 );
			wrk[loop_cnt-1] = '|';
			wrk[loop_cnt] = '\0';
		}
		else{
			wrk[0] = '|';
			wrk[1] = '\0';
		}
		
		/* ovo */
		loop_max = loop_cnt;
		pare_cnt = 0;
		for( loop_cnt = 0; loop_cnt < loop_max; loop_cnt++ ){
			/* qXLbv */
			if( *(p_start_pare+loop_cnt) == '(' )pare_cnt++;
			if( *(p_start_pare+loop_cnt) == ')' )pare_cnt--;
			if( pare_cnt > 1 )continue;;
			
			/* QoCgPoCgڂ̏ꍇ̓XLbviShift_JIŜ݁j */
			if( strcmp( GStrDicCode, "Shift_JIS" ) == 0 ){
				if( multi_byte_chk( (int)wrk[loop_cnt] ) ){
					loop_cnt++;
					continue;
				}
			}
			
			/* o؂蔭 */
			if( wrk[loop_cnt] == ':' ){
				if( sscanf( &wrk[loop_cnt], ":%ld", &ratio ) == 1 ){
					ratio_total += ratio;
					/* ̋؂܂ŃXLbv */
					while( wrk[loop_cnt] != '|' && wrk[loop_cnt] != '\0' )loop_cnt++;
					if( wrk[loop_cnt] == '\0' )break;
					continue;
				}
			}
			
			/* ؂蔭io͏ȗĂj */
			if( wrk[loop_cnt] == '|' ){
				ratio_total += 1;	//ftHgl͂Pł
				continue;
			}
			
			/* I[ɗI */
			if( wrk[loop_cnt] == '\0' )break;
		}
		
		/* ^[Qbg̋I */
		unsigned long target = get_rnd_num( ratio_total );

		/* ^[Qbg̋؂o */
		loop_max = loop_cnt;
		p_wrk = wrk;
		pare_cnt = 0;
		for( loop_cnt = 0; loop_cnt < loop_max; loop_cnt++ ){
			
			if( *(p_start_pare+loop_cnt) == '(' )pare_cnt++;
			if( *(p_start_pare+loop_cnt) == ')' )pare_cnt--;
			if( pare_cnt > 1 )continue;;
			
			/* QoCgPoCgڂ̏ꍇ̓XLbviShift_JIŜ݁j */
			if( strcmp( GStrDicCode, "Shift_JIS" ) == 0 ){
				if( multi_byte_chk( (int)wrk[loop_cnt] ) ){
					loop_cnt++;
					continue;
				}
			}
			
			/* o؂蔭 */
			if( wrk[loop_cnt] == ':' ){
				if( sscanf( &wrk[loop_cnt], ":%ld", &ratio ) == 1 ){
					if( target <= ratio ){
						/* ؂oi':'ȍ~Jbgj */
						wrk[loop_cnt] = '\0';
						break;
					}
					else{
						target -= ratio;
						/* ̋؂܂ŃXLbv */
						while( wrk[loop_cnt] != '|' && wrk[loop_cnt] != '\0' )loop_cnt++;
						if( wrk[loop_cnt] == '\0' )break;
						p_wrk = &wrk[loop_cnt+1];
						continue;
					}
				}
			}
			
			/* ؂蔭io͏ȗĂj */
			if( wrk[loop_cnt] == '|' ){
				if( target <= 1 ){
					/* ؂o */
					wrk[loop_cnt] = '\0';
					break;
				}
				else{
					target -= 1;	//ftHgl͂Pł
					p_wrk = &wrk[loop_cnt+1];
					continue;
				}
			}
			
			/* I[ɗI */
			if( wrk[loop_cnt] == '\0' )break;
			
		}
		
		/* ؂oꂽu */
		strmov( p_end_pare+1, p_start_pare + strlen(p_wrk) );
		memcpy( p_start_pare, p_wrk, strlen(p_wrk) );
		
	}
	
	return(0);
	
}

/************************************************************************/
/* 			֐ł͂Ȃŏ̊ۊʂT								*/
/************************************************************************/
char* get_nonfunc_endpare( char* buf )
{
	
	char* p_wrk;
	char* p_wrk2;
	int loop_cnt;
	int func_action_flg;
	
	p_wrk = buf;
	
	while( ( p_wrk2 = strchr(p_wrk, '(' ) ) != NULL ){
		/* e֐ƔrsȂ */
		func_action_flg = 0;
		for( loop_cnt = 0; GEseFunc[loop_cnt].scr_func != NULL; loop_cnt++ ){
			if( (unsigned)(p_wrk2-buf) < strlen(GEseFunc[loop_cnt].scr_func) )continue;
			if( chk_after_str( p_wrk2, GEseFunc[loop_cnt].scr_func ) == 0 ){
				func_action_flg = 1;
				break;
			}
		}
		
		/* ֐ƈv */
		if( func_action_flg == 1 ){
			p_wrk = p_wrk2+1;
			continue;
		}
		
		/* POPʎqƔrsȂ */
		if( (unsigned)(p_wrk2-buf) >= strlen("POPSTR") ){
			if( chk_after_str( p_wrk2, "POPSTR" ) == 0 ){
				p_wrk = p_wrk2+1;
				continue;
			}
		}
		if( (unsigned)(p_wrk2-buf) >= strlen("POPNUM") ){
			if( chk_after_str( p_wrk2, "POPNUM" ) == 0 ){
				p_wrk = p_wrk2+1;
				continue;
			}
		}
		if( (unsigned)(p_wrk2-buf) >= strlen("POP") ){
			if( chk_after_str( p_wrk2, "POP" ) == 0 ){
				p_wrk = p_wrk2+1;
				continue;
			}
		}
		/* ֐Ȃ̂t */
		break;
		
	}
	
	return(p_wrk2);
	
}

/************************************************************************/
/* 			w|C^OɎw蕶񂪂邩ǂ`FbN			*/
/************************************************************************/
int chk_after_str( char* buf, char* str )
{
	int len = strlen(str);
	return( memcmp( buf-len, str, len ) );
}

/************************************************************************/
/* 			Shift_JISR[ĥQoCgPoCgڃ`FbN				*/
/************************************************************************/
int multi_byte_chk( int c )
{
	c = c & 0x000000ff;
	if( c >= 0x81 && c <= 0x9f || c >= 0xe0 && c <= 0xfc )return(1);
	else return(0);
}

/************************************************************************/
/* 			SpЉSpɕϊ								*/
/************************************************************************/
int chg_kata_to_hira( unsigned char* buf )
{
	unsigned int h,l,w1,w2;
	
	h = (int)*buf;
	l = (int)*(buf+1);
	w1 = h * 0x100 + l;
	
	if( h == 0x83 && ( l >= 0x40 && l <= 0x93 ) ){
		w2 = w1 - 0xa1;
		if( l >= 0x80 )w2--;
	}
	else w2 = w1;
	
	*buf     = (unsigned char)( ( w2 & 0x0000ff00 ) / 0x100 );
	*(buf+1) = (unsigned char)(   w2 & 0x000000ff  ) ;
	
	return(0);
	
}

