#include <windows.h>
//#include <vcl\vcl.h>
#include <string.h>
#include <stdio.h>
#include <io.h>
#include <time.h>
#include <mbstring.h>
#include <tlhelp32.h>
#include "ese_acc_saori.h"
#include "ese_general.h"
#include "ese_global.h"
#include "ese_dokoitsu.h"
#include "ese_db.h"
#include "ese_common.h"
#include "gurongi.h"

//---------------------------------------------------------------------------
//#define DEBUG 1

int act_func( char* buf, char* input_buf, int timing );
int chg_pop_to_str(char* buf);
int get_rnd_entry(char* buf);
int back_rnd_entry(char* buf);
int set_tag_select_style(char* buf);
int set_tag_select_flg(char* buf);
int get_ghost(char* buf);
int get_entry(char* buf);
int get_paragraph(char* buf);
int set_paragraph(char* buf);
int set_string(char* buf);
int get_set_specific_word(char* buf);
int get_sent_str_ll(char* buf);
int get_sent_str_lr(char* buf);
int get_sent_str_rl(char* buf);
int get_sent_str_rr(char* buf);
int get_sent_str_sub(char* buf,char first,char second);
int get_string_mid(char* buf);
int get_string_left(char* buf);
int get_string_right(char* buf);
int get_string_length(char* buf);
int read_file_to_push(char* buf);
int write_file_from_pop(char* buf);
int write_file_from_pop_app(char* buf);
int write_file_from_pop_sub(char* buf, int flg);
int set_random_num(char* buf);
int set_reflect(char* buf);
int chk_ifelse(char* buf);
char* next_elseendif( char* buf, int* type );
char* last_endif( char* buf );
int chk_if_sub(char* buf);
int change_gurongi(char* buf);
int calc(char* buf);
int talk_interval(char* buf);
int read_news(char* buf);
int news_interval(char* buf);
int set_news_count(char* buf);
int set_header_code(char* buf);
int set_entry_data(char* buf);
int del_entry_data(char* buf);
int acc_entry_data(char* buf,int acc_flg);
int access_user_dic( char* entry, char* word, char* filename, int acc_flg );
int self_event( char* buf );
int getarg_str_num_num(char* buf, char* get_buf, int* arg2, int* arg3);
int get_last2arg(char* buf, int* arg1, int* arg2);
int set_stack(char* buf, char* get_str, int stack_no, int mode);
int remove_function(char* buf);

extern int read_dic(void);




//shioriXNvg̊֐yя[`̃e[u
str_ese_func GEseFunc[] = {
		{	"TREE",			remove_function			},
		{	"DUMMY",		remove_function			},
		{	"MODE",			get_rnd_entry			},
		{	"REMODE",		back_rnd_entry			},
		{	"TAGSEL_STYLE",	set_tag_select_style	},
		{	"SETTAGSEL_FLG",set_tag_select_flg		},
		{	"GETGHOST",		get_ghost				},
		{	"GETENTRY",		get_entry				},
		{	"PUSH",			get_paragraph			},
		{	"RAND",			set_random_num			},
		{	"POP",			set_paragraph			},
		{	"THROUGH",		set_string				},
		{	"IF",			chk_ifelse				},
		{	"ELSEIF",		remove_function			},
		{	"ELSE",			remove_function			},
		{	"ENDIF",		remove_function			},
		{	"GURONGI",		change_gurongi			},
		{	"CALC",			calc					},
		{	"TALK_INTERVAL",talk_interval			},
		{	"READNEWS",		read_news				},
		{	"NEWS_INTERVAL",news_interval			},
		{	"NEWSCOUNTER",	set_news_count			},
		{	"MKHEADER",		set_header_code			},
		{	"SETENTRY",		set_entry_data			},
		{	"DELENTRY",		del_entry_data			},
		{	"REFLECT",		set_reflect				},
		{	"GETSENTRES",	get_set_specific_word	},
		{	"GETPOP",		get_set_specific_word	},
		{	"GETSENTSTR_LL",get_sent_str_ll			},
		{	"GETSENTSTR_LR",get_sent_str_lr			},
		{	"GETSENTSTR_RL",get_sent_str_rl			},
		{	"GETSENTSTR_RR",get_sent_str_rr			},
		{	"GETSENTSTR",	get_sent_str_ll			},
		{	"GETSTRMID",	get_string_mid			},
		{	"GETSTRLEFT",	get_string_left			},
		{	"GETSTRRIGHT",	get_string_right		},
		{	"STRLENGTH",	get_string_length		},
		{	"READFILE",		read_file_to_push		},
		{	"WRITEFILEAP",	write_file_from_pop_app	},
		{	"WRITEFILE",	write_file_from_pop		},
		{	"SELFEVENT",	self_event				},
		{	"SSAORI",		access_saori_single		},
		{	"MSAORI",		access_saori_multi		},
		{	"ESQL_SELECT",	esesql_select			},
		{	NULL,			NULL					}
};



/************************************************************************/
/* 			t@NVni$??j									*/
/************************************************************************/
int act_func( char* buf, char* input_buf, int timing )
{

	char wrk[512];
	char* p_wrk;
	char* p_now;
	int err_cnt;
	int selfevent_wrk;
	
	/* ݂̎ƃCxgo^ޔ */
	selfevent_wrk = GSelfEventNum;
	
	/* [珇ɏ */
	p_now = buf;
	for( err_cnt = 0; err_cnt < 999; err_cnt++ ){
		if( ( p_wrk = strchr( p_now, '$' ) ) == NULL )break;
		log_write_user( "--------------------------------------", "ese_fncanl.log", GDBGFncAnalysis );
		log_write_user( buf, "ese_fncanl.log", GDBGFncAnalysis );
		log_write_user( p_wrk, "ese_fncanl.log", GDBGFncAnalysis );

		/* ֐ǂ`FbNA֐Ȃs */
		int func_action_flg = 0;
		int loop_cnt;
		for( loop_cnt = 0; GEseFunc[loop_cnt].scr_func != NULL; loop_cnt++ ){
			memset( wrk, '_', timing+1 );
			wrk[0] = '$';
			strcpy( &wrk[timing+1], GEseFunc[loop_cnt].scr_func );
			if( memlcmp( p_wrk, wrk ) == 0 ){
				/* shiori̊֐̂Ŋ֐ʓʎqϊRRōsȂ */
				chg_pop_to_str(p_wrk);
				
				log_write_user( p_wrk, "ese_fncanl.log", GDBGFncAnalysis );
				log_write_user( "+++++", "ese_fncanl.log", GDBGFncAnalysis );
				
				
				if( GEseFunc[loop_cnt].prg_func( p_wrk ) != 0 )p_wrk++;
				p_now = p_wrk;
				func_action_flg = 1;
				break;
			}
		}
		if( func_action_flg == 1 )continue;

		/* ֐Ȃꍇ͎̈ʒu */
		p_now = p_wrk + 1;
		
	}
	
	log_write_user( buf, "ese_fncanl.log", GDBGFncAnalysis );
	
	/* IFƂőSꍇ͕ʂ̕쐬 */
	/* iƃCxgo^sȂꂽɑSꂽꍇ */
	/*  @ʂ̍̕쐬͍sȂȂj*/
	if( *buf == '\0' && selfevent_wrk == GSelfEventNum ){
		return(1);
	}
	
	/* ŏIʂ߂lɃZbgi֐XXXzG[ɂj */
	if( err_cnt == 999 )strcpy( buf, "ESESHIORI ERROR" );
	
	return(0);
	
}

/************************************************************************/
/*				擪֐̃ʎqϊ							*/
/************************************************************************/
int chg_pop_to_str(char* buf)
{
	
	char wrk[1024];
	char wrk2[64];
	char wrk3[64];
	char wrk4[64];
	char* p_popstart;
	char* p_start;
	char* p_end;
	long wrkl;
	int stack_no;
	int loop_cnt;
	int loop_cnt2;
	int loop_cnt3;
	int flg = 0;
	int len;
	int next_str_point;
	int put_size;
	
	/*  */
	len = strlen(buf);
	loop_cnt = 0;
	while( *(buf+loop_cnt) != '(' ){
		loop_cnt++;
		/* ʂ݂Ȃꍇ̓G[I */
		if( loop_cnt > len )return(1);
	}
	for( ; loop_cnt < len; loop_cnt++ ){
		/* _uNH[e[V`FbN */
		if( *(buf+loop_cnt) == '\"' ){
			if( flg == 0 ){
				/*  */
				flg = 1;
				continue;
			}
			else{
				/* o */
				flg = 0;
				continue;
			}
		}
		
		/* NH[e[V */
		if( flg == 1 )continue;
		
		/* iȍ~͕KNH[e[VOłj */
		
		/* ʎq擾 */
		if( memlcmp( buf+loop_cnt, "POP(" ) == 0 ){
			/* ʎqJnʒuL */
			p_popstart = buf+loop_cnt;
			
			/* NOǂݎ */
			if( sscanf( p_popstart, "POP( %d", &stack_no ) == 1 ){
				if( stack_no > PUSH_NUM )stack_no = 0;
				else if( stack_no < 1 )	 stack_no = 0;
				else					 stack_no--;
			}
			else stack_no = 0;
			
			/* POP()̊ʕ܂Ń|C^ړāA\ȍ~L */
			while( *(buf+loop_cnt) != ')' )loop_cnt++;
			next_str_point = loop_cnt+1;
			
			if( GStack[stack_no] != NULL )put_size = strlen( GStack[stack_no] )+2;
			else						  put_size = 2;
			
			strmov( buf+next_str_point, p_popstart+put_size );
			if( GStack[stack_no] != NULL )strcpy( p_popstart+1, GStack[stack_no] );
			*p_popstart = *(p_popstart+put_size-1) = '\"';
			loop_cnt = p_popstart - buf + put_size;		//NH[e[V̎Ɉړ
			len = strlen(buf);			/* 񒷂Ď擾 */
			continue;
			
		}
		
		/* Vʎqij擾 */
		if( memlcmp( buf+loop_cnt, "POPSTR(" ) == 0 ){
			/* ʎqJnʒuL */
			p_popstart = buf+loop_cnt;
			
			/* NOǂݎ */
			if( sscanf( p_popstart, "POPSTR( %d", &stack_no ) == 1 ){
				if( stack_no > PUSH_NUM )stack_no = 0;
				else if( stack_no < 1 )	 stack_no = 0;
				else					 stack_no--;
			}
			else stack_no = 0;
			
			/* POP()̊ʕ܂Ń|C^ړāA\ȍ~L */
			while( *(buf+loop_cnt) != ')' )loop_cnt++;
			next_str_point = loop_cnt+1;
			
			if( GStack[stack_no] != NULL )put_size = strlen( GStack[stack_no] )+2;
			else						  put_size = 2;
			
			strmov( buf+next_str_point, p_popstart+put_size );
			if( GStack[stack_no] != NULL )strcpy( p_popstart+1, GStack[stack_no] );
			*p_popstart = *(p_popstart+put_size-1) = '\"';
			loop_cnt = p_popstart - buf + put_size;		//NH[e[V̎Ɉړ
			len = strlen(buf);			/* 񒷂Ď擾 */
			continue;
			
		}
		
		/* Vʎqij擾 */
		if( memlcmp( buf+loop_cnt, "POPNUM(" ) == 0 ){
			/* ʎqJnʒuL */
			p_popstart = buf+loop_cnt;
			
			/* NOǂݎ */
			if( sscanf( p_popstart, "POPNUM( %d", &stack_no ) == 1 ){
				if( stack_no > PUSH_NUM )stack_no = 0;
				else if( stack_no < 1 )	 stack_no = 0;
				else					 stack_no--;
			}
			else stack_no = 0;
			
			/* POP()̊ʕ܂Ń|C^ړāA\ȍ~L */
			while( *(buf+loop_cnt) != ')' )loop_cnt++;
			next_str_point = loop_cnt+1;
			
			if( GStack[stack_no] != NULL )put_size = strlen( GStack[stack_no] );
			else						  put_size = 0;
			
			if( put_size != 0 ){
				strmov( buf+next_str_point, p_popstart+put_size );
				if( GStack[stack_no] != NULL )memcpy( p_popstart, GStack[stack_no], strlen(GStack[stack_no]) );
			}
			else{
				strmov( buf+next_str_point, p_popstart+1 );
				*p_popstart = '0';
			}
			
			loop_cnt = p_popstart - buf;		//NH[e[V̎Ɉړ
			len = strlen(buf);			/* 񒷂Ď擾 */
			continue;
			
		}
		
		/* [hʎq擾 */
		if( memlcmp( buf+loop_cnt, "MODE" ) == 0 ){
			/* [hʎqJnʒuL */
			p_popstart = buf+loop_cnt;
			
			/* [hʎqȍ~L */
			next_str_point = loop_cnt+strlen("MODE");
			
			put_size = strlen( GRndEntry );
			
			strmov( buf+next_str_point, p_popstart+put_size+2 );
			strcpy( p_popstart+1, GRndEntry );
			*p_popstart = *(p_popstart+put_size+1) = '\"';
			loop_cnt = p_popstart - buf + put_size;		//NH[e[V̎Ɉړ
			len = strlen(buf);			/* 񒷂Ď擾 */
			continue;
			
		}
		
		/* ʕŏI */
		if( *(buf+loop_cnt) == ')' )break;
		
	}
	
	/* ֐ʓ̔pXy[XSċl߂ */
	len = strlen(buf);
	loop_cnt = 0;
	while( *(buf+loop_cnt) != '(' )loop_cnt++;
	for( ; loop_cnt < len; loop_cnt++ ){
		/* _uNH[e[V`FbN */
		if( *(buf+loop_cnt) == '\"' ){
			if( flg == 0 ){
				/*  */
				flg = 1;
				continue;
			}
			else{
				/* o */
				flg = 0;
				continue;
			}
		}
		
		/* NH[e[V */
		if( flg == 1 )continue;
		
		/* iȍ~͕KNH[e[VOłj */
		
		/* ֐NH[e[VO̔pXy[X͋l߂ */
		if( *(buf+loop_cnt) == ' ' ){
			strmov( buf+loop_cnt+1, buf+loop_cnt );
			loop_cnt--;
			continue;
		}
		
		/* ʕŏI */
		if( *(buf+loop_cnt) == ')' )break;
		
	}
	
	/* Aq */
	len = strlen(buf);
	loop_cnt = 0;
	while( *(buf+loop_cnt) != '(' )loop_cnt++;
	for( ; loop_cnt < len; loop_cnt++ ){
		/* _uNH[e[V`FbN */
		if( *(buf+loop_cnt) == '\"' ){
			if( flg == 0 ){
				/*  */
				flg = 1;
				continue;
			}
			else{
				/* o */
				flg = 0;
				continue;
			}
		}
		
		/* NH[e[V */
		if( flg == 1 )continue;
		
		/* iȍ~͕KNH[e[VOłj */
		
		/* "~"l߂ */
		if( *(buf+loop_cnt) == '~' ){
			if( *(buf+loop_cnt-1) == '\"' &&
				*(buf+loop_cnt+1) == '\"' ){
				strmov( buf+loop_cnt+2, buf+loop_cnt-1 );
				loop_cnt-=2;
				flg = 1;
				continue;
			}
		}
		
		/* ʕŏI */
		if( *(buf+loop_cnt) == ')' )break;
		
	}
	
	/* ľvZs */
	loop_cnt = 0;
	while( *(buf+loop_cnt) != '(' )loop_cnt++;
	loop_cnt++;
	for( loop_cnt2 = 0; loop_cnt2 < 20 ; loop_cnt2++ ){
		get_comma_lenword( buf+loop_cnt, wrk, loop_cnt2, 1020 );
		if( wrk[0] == '\0' )break;
		if( wrk[0] == '\"' )continue;
		
		/* Y̊JnʒuEIʒuEL */
		p_start = strstr( buf+loop_cnt, wrk );
		p_end = p_start + strlen(wrk);
		
		/* IFn֐̏ꍇ͈rŐȊO\̂ŕ */
		if( strchr( wrk, '>' ) != NULL ||
			strchr( wrk, '<' ) != NULL ||
			strchr( wrk, '=' ) != NULL ){
			len = strlen( wrk );
			for( loop_cnt3 = 0; loop_cnt3 < len; loop_cnt3++ ){
				if( wrk[loop_cnt3] == '>' || wrk[loop_cnt3] == '<' ||
					wrk[loop_cnt3] == '=' ){
					/* ʎqۑ */
					memcpy( wrk2, &wrk[loop_cnt3], 2 );
					if( wrk2[1] != '>' && wrk2[1] != '<' && wrk2[1] != '=' ){
						wrk2[1] = '\0';
					}
					else{
						wrk2[2] = '\0';
					}
					
					/* ӌvZ */
					wrk[loop_cnt3] = '\0';
					wrkl = calc_string( wrk );
					ltoa( wrkl, wrk3, 10 );
					
					/* EӌvZ */
					wrkl = calc_string( &wrk[loop_cnt3+strlen(wrk2)] );
					ltoa( wrkl, wrk4, 10 );
					
					/* q */
					strcpy( wrk, wrk3 );
					strcat( wrk, wrk2 );
					strcat( wrk, wrk4 );
					
					break;
				}
			}
		}
		else{
			/* vZ */
			wrkl = calc_string( wrk );
			
			/* ɕϊ */
			ltoa( wrkl, wrk, 10 );
		}
		
		/* u */
		len = strlen( wrk );
		strmov( p_end, p_start + len );
		memcpy( p_start, wrk, len );
		
	}
	
	return(0);

}


/************************************************************************/
/*				_g[NpGgύX							*/
/************************************************************************/
int get_rnd_entry(char* buf)
{
	
	char wrk[2048];
	char wrk2[2048];
	char* p_wrk;
	
	/* VGg擾 */
	p_wrk = strchr( buf, '\"' );
	if( p_wrk == NULL )return(1);		/* ""ŊĂȂ̂ŃG[ */
	strncpy( wrk, p_wrk+1, 2040 );
	wrk[2040] = '\0';
	p_wrk = strchr( wrk, '\"' );
	if( p_wrk == NULL )return(1);		/* ""ŊĂȂ̂ŃG[ */
	*p_wrk = '\0';
	
	/* ݃GgobNAbvɕۑiPO܂Łj */
	memmov( GRndEntryOld[0], GRndEntryOld[1], 6*9 );
	memcpy( GRndEntryOld[0], GRndEntry, 5 );
	
	/* VGg擾 */
	if( strlen( wrk ) > 127 ){
		memcpy( GRndEntry, wrk, 127 );
		wrk[127] = '\0';
	}
	else strcpy( GRndEntry, wrk );
	
	/* ΏےP擾 */
	strncpy( wrk2, p_wrk+1, 2040 );
	wrk2[2040] = '\0';
	p_wrk = strchr( wrk2, '\"' );
	if( p_wrk == NULL )return(1);		/* ""ŊĂȂ̂ŃG[ */
	strncpy( wrk, p_wrk+1, 2040 );
	wrk[2040] = '\0';
	p_wrk = strchr( wrk, '\"' );
	if( p_wrk == NULL )return(1);		/* ""ŊĂȂ̂ŃG[ */
	*p_wrk = '\0';

	/* ƔrāA900ɃZbg */
	unsigned long loop_cnt;
	char str_type[7];
	StrDicPnt* p_ai_dic = GAiDic;
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
		if( strcmp( (p_ai_dic+loop_cnt)->string, wrk ) == 0 ){
			/* ̒PɊY敪擾 */
			str_type[0] = 's';
			ulong_to_str( (p_ai_dic+loop_cnt)->entry_no, &str_type[1] );

			/* ̒P𗚗XOOɓo^ */
			GStrMemCnt = 0;
			memset( GStrMemory, 0, sizeof(int)*889 );
			GStrMemory[900] = loop_cnt;

			break;
		}
	}
	
	/* 폜 */
	remove_function(buf);
	
	return(0);
}


/************************************************************************/
/*		ۑꂽ_g[NpGg߂iPO܂Łj		*/
/************************************************************************/
int back_rnd_entry(char* buf)
{
	
	int generation;
	char* p_wrk;
	
	/* ߂㐔擾 */
	p_wrk = strchr( buf, '(' );
	if( p_wrk == NULL )return(1);		/* \G[ */
	if( sscanf( p_wrk+1, " %d", &generation ) != 1 )generation = 1;
	if( generation > 10 || generation < 1 ){
		/* ُ͈͂Ȃ̂Ŗ */
		remove_function(buf);
		return(1);
	}
	
	/* YGg擾AZbg */
	memcpy( GRndEntry, GRndEntryOld[generation-1], 5 );
	
	/* GgobNAbvtbV */
	memmov( GRndEntryOld[0], GRndEntryOld[generation], 6*(10-generation) );
	memset( GRndEntryOld[10-generation], '\0', 6*generation );
	
	/* 폜 */
	remove_function(buf);
	
	return(0);
}


/************************************************************************/
/*		^OI̕@w肷										*/
/************************************************************************/
int set_tag_select_style(char* buf)
{
	
	char entry_type;
	char entry[130];
	char wrk[128];
	char* p_wrk = buf;
	long select_no;
	unsigned long select_style;
	unsigned long start_no;
	unsigned long end_no;
	unsigned long loop_cnt;
	int tag_len;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, entry, 0, 128 );
	delete_doublequotation( entry );
	entry_type = entry[0];
	
	/* QER擾 */
	get_comma_lenword( p_wrk, wrk, 1, 60 );
	if( wrk[0] != '\0' )sscanf( wrk, "%ld", &select_style );
	get_comma_lenword( p_wrk, wrk, 2, 60 );
	select_no = 0L;
	if( wrk[0] != '\0' ){
		if( sscanf( wrk, "%ld", &select_no ) != 1 )select_no = 0L;
	}
	
	/* GgGgԍ擾 */
	if( getstr_from_nmlentry( entry, &start_no, &end_no, &tag_len ) != 0 ){
		/* ݂ȂGgw肳ꂽꍇ */
		remove(buf);
		return(1);
	}
	
	/* YGgTđI^CvZbg */
	StrDicPnt* p_ai_dic = GAiDic;
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++, p_ai_dic++ ){
		if( p_ai_dic->entry_type != ' ' )continue;
		if( memcmp( p_ai_dic->string+1, entry, tag_len )!=0 )continue;
		
		/* YGgȂ̂ŒlZbgă[vI */
		p_ai_dic->tag_sel_style = select_style;
		break;
	}
	
	/* ^OȈsȂ */
	if( select_style == 0 ){
		/* _͉Ȃ */
	}
	if( select_style == 1 ){
		/* ǂݎ */
		if( select_no > 0L ){
			p_ai_dic = GAiDic;
			for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
				/* wGgɑ邩ǂ`FbN */
				if( (p_ai_dic+loop_cnt)->entry_type == entry_type &&
					(p_ai_dic+loop_cnt)->entry_no   >= start_no &&
					(p_ai_dic+loop_cnt)->entry_no   <= end_no){
					
					/* wf[^̒O܂DONEf[^ɂ */
					select_no--;
					if( select_no > 0L )(p_ai_dic+loop_cnt)->tag_sel_flg = TAGSEL_DONE;
					else				(p_ai_dic+loop_cnt)->tag_sel_flg = TAGSEL_OK;
				}
			}
		}
	}
	if( select_style == 2 ){
		/* dȂȂ_ */
		if( select_no > 0L ){
			p_ai_dic = GAiDic;
			for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
				/* wGgɑ邩ǂ`FbN */
				if( (p_ai_dic+loop_cnt)->entry_type == entry[0] &&
					(p_ai_dic+loop_cnt)->entry_no   >= start_no &&
					(p_ai_dic+loop_cnt)->entry_no   <= end_no){
					
					/* Yf[^͑SOKf[^ɂ */
					(p_ai_dic+loop_cnt)->tag_sel_flg = TAGSEL_OK;
				}
			}
		}
	}
	
	remove_function( buf );
	
	return(0);
}


/************************************************************************/
/*		^OĨtOlZbg									*/
/************************************************************************/
int set_tag_select_flg(char* buf)
{
	StrDicPnt* p_ai_dic = GAiDic;
	char entry[130];
	char tagdata[4096];
	char wrk[64];
	char* p_wrk = buf;
	unsigned long start_no;
	unsigned long end_no;
	unsigned long loop_cnt;
	int tagsel_flg;
	int taglen;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* PAQ擾 */
	get_comma_lenword( p_wrk, entry, 0, 128 );
	delete_doublequotation( entry );
	get_comma_lenword( p_wrk, tagdata, 1, 4090 );
	delete_doublequotation( tagdata );
	
	/* R擾 */
	get_comma_lenword( p_wrk, wrk, 2, 60 );
	if( wrk[0] != '\0' )sscanf( wrk, "%d", &tagsel_flg );
	
	/* YGg̊Yf[^݂f[^s擾 */
	if( getstr_from_nmlentry( entry, &start_no, &end_no, &taglen ) != 0 ){
		/* wGg݂͑Ȃ̂ŏI */
		remove_function( buf );
		return(1);
	}
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
		/* wGgɑ邩ǂ`FbN */
		if( (p_ai_dic+loop_cnt)->entry_type == entry[0] &&
			(p_ai_dic+loop_cnt)->entry_no   >= start_no &&
			(p_ai_dic+loop_cnt)->entry_no   <= end_no){
			
			/* vf[^ꍇ̓^OItOɒlZbgďI */
			if( strcmp( (p_ai_dic+loop_cnt)->string, tagdata ) == 0 ){
				(p_ai_dic+loop_cnt)->tag_sel_flg = tagsel_flg;
				break;
			}
			
		}
	}
	
	remove_function( buf );
	
	return(0);
	
}


/************************************************************************/
/*				̃S[Xg邩ǂ擾							*/
/************************************************************************/
int get_ghost(char* buf)
{
	
	char ghost[1024];
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	int loop_cnt;
	
	/* 擾 */
	if( getarg_str_num_num( buf, ghost, &stack_no, &mode ) != 0 )return(1);
	
	/* S[Xĝ or ΏۃS[Xg̏ꍇAREFLECT͖ */
	if( GOtherGhostNum == 0 || ( strcmp( ghost, GGhostName ) == 0 && GGhostName[0] != '\0' ) ){
		ghost[0] = '\0';
	}
	/* ΏۃS[Xgw肳ĂȂꍇA_őΏۃS[Xg擾 */
	else if( ghost[0] == '\0' ){
		strcpy( ghost, GOtherGhostName[get_rnd_num(GOtherGhostNum)-1] );
	}
	/* ΏۃS[Xgw肳Ăꍇ */
	else{
		/* wS[XgΎwS[XgcAȂ΃S[Xg */
		for( loop_cnt = 0; loop_cnt < GOtherGhostNum; loop_cnt++ ){
			if( strcmp( ghost, GOtherGhostName[loop_cnt] ) == 0 )break;
		}
		if( loop_cnt == GOtherGhostNum )ghost[0] = '\0';
	}
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, ghost, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				w肳ꂽ̑Gg擾				*/
/************************************************************************/
int get_entry(char* buf)
{
	
	StrEntryList* entry_list_wrk = GEntryList;
	char word[1024];
	char str_type[128];
	unsigned long loop_cnt;
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	
	/* 擾 */
	if( getarg_str_num_num( buf, word, &stack_no, &mode ) != 0 )return(1);
	
	/* w蕶ƈr */
	StrDicPnt* p_ai_dic = GAiDic;
	for( loop_cnt = 0; loop_cnt < GAiDicLine; loop_cnt++ ){
		if( strcmp( (p_ai_dic+loop_cnt)->string, word ) == 0 ){
			/* ̒PɊY敪擾 */
			for( ; entry_list_wrk->start_no != -1; entry_list_wrk++ ){
				if( entry_list_wrk->start_no == (int)((p_ai_dic+loop_cnt)->entry_no) &&
					entry_list_wrk->end_no == (int)((p_ai_dic+loop_cnt)->entry_no) &&
					*(entry_list_wrk->string) == (p_ai_dic+loop_cnt)->entry_type &&
					strchr( entry_list_wrk->string, '*' ) == NULL ){
					
					str_type[0] = '#';
					strcpy( &str_type[1], entry_list_wrk->string );
					str_type[127] = '\0';
					loop_cnt = GAiDicLine;
					break;
				}
			}
		}
	}
	if( loop_cnt == GAiDicLine )str_type[0] = '\0';
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, str_type, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				߂̋L											*/
/************************************************************************/
int get_paragraph(char* buf)
{
	
	char wrk[4096];
	char wrk2[64];
	char* p_wrk = buf;
	int stack_no = 1;
	int mode = PARAGRAPH_VISIBLE;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, wrk, 0, 4090 );
	delete_doublequotation( wrk );
	
	/* QER擾 */
	get_comma_lenword( p_wrk, wrk2, 1, 60 );
	if( wrk2[0] != '\0' )sscanf( wrk2, "%d", &stack_no );
	get_comma_lenword( p_wrk, wrk2, 2, 60 );
	if( wrk2[0] != '\0' )sscanf( wrk2, "%d", &mode );
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, wrk, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				͕̎w蕶؂o							*/
/************************************************************************/
int get_set_specific_word(char* buf)
{
	
	char first_word[1024];
	char second_word[1024];
	char wrk[4096];
	char* p_wrk;
	char* p_wrk2;
	int stack_no = 0;
	int moto_stack_no;
	int mode = PARAGRAPH_VISIBLE;
	int ret_cd;
	
	/* POP-NO擾iΓ͕POP(99)Ƃj */
	p_wrk = strchr( buf, '(' );
	if( p_wrk != NULL ){
		ret_cd = sscanf( p_wrk, "( %d", &moto_stack_no );
		
		/* l̑ÓȂǂ`FbNĒ */
		if( ret_cd == 1 && moto_stack_no > PUSH_NUM )moto_stack_no = 0;
		else if( ret_cd == 1 && moto_stack_no < 1 )	 moto_stack_no = 0;
		else if( ret_cd == 1 )						 moto_stack_no--;
		else										 moto_stack_no = PUSH_EVENT_ALLSENTENCE;
	}
	else{
		return(1);		/* '('̂ŃG[ */
	}
	
	/* Pڂ擾 */
	p_wrk = strchr( buf, '\"' );
	if( p_wrk == NULL ){
		return(1);		/* ""ŊĂȂ̂ŃG[ */
	}
	strncpy( first_word, p_wrk+1, 1020 );
	p_wrk = strchr( first_word, '\"' );
	if( p_wrk == NULL ){
		return(1);		/* ""ŊĂȂ̂ŃG[ */
	}
	*p_wrk = '\0';
	
	/* Qڂ擾 */
	p_wrk = strchr( buf, '\"' );
	if( p_wrk == NULL ){
		return(1);		/* ""ŊĂȂ̂ŃG[ */
	}
	p_wrk2 = strchr( p_wrk+1, '\"' );
	if( p_wrk2 == NULL ){
		return(1);		/* ""ŊĂȂ̂ŃG[ */
	}
	p_wrk = strchr( p_wrk2+1, '\"' );
	if( p_wrk == NULL ){
		return(1);		/* ""ŊĂȂ̂ŃG[ */
	}
	
	memcpy( second_word, p_wrk+1, 1020 );
	*(second_word+1020) = '\0';
	p_wrk = strchr( second_word, '\"' );
	if( p_wrk == NULL ){
		return(1);		/* ""ŊĂȂ̂ŃG[ */
	}
	*p_wrk = '\0';
	
	/* X^bN[hǂAyѓ샂[h擾 */
	get_last2arg( p_wrk+1, &stack_no, &mode );
	
	/* ƂȂ镶pӂ */
	if( GStack[moto_stack_no] != NULL ){
		strncpy( wrk, GStack[moto_stack_no], 4090 );
		wrk[4090] = '\0';
	}
	else wrk[0] = '\0';
	
	/* wŋ܂ꂽӏ */
	p_wrk = strstr( wrk, first_word );
	if( p_wrk == NULL ){
		wrk[0] = '\0';
		p_wrk = wrk;
	}
	else{
		p_wrk = p_wrk + strlen( first_word );
		p_wrk2 = strstr( p_wrk, second_word );
		if( *second_word == '\0' );	//㔼w肪ꍇ͂K؂Ȃ
		else if( p_wrk2 == NULL ){	//㔼w肪Ȃꍇ͓؂
			wrk[0] = '\0';
			p_wrk = wrk;
		}
		else *p_wrk2 = '\0';		//㔼w畁ʂɂK؂
	}
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, p_wrk, stack_no, mode);

	return(0);
}


/************************************************************************/
/*				ƕɋ܂ꂽ񔲂oij			*/
/************************************************************************/
int get_sent_str_ll(char* buf)
{
	return( get_sent_str_sub( buf, 'l', 'l' ) );
}


/************************************************************************/
/*				ƕɋ܂ꂽ񔲂oiEj			*/
/************************************************************************/
int get_sent_str_lr(char* buf)
{
	return( get_sent_str_sub( buf, 'l', 'r' ) );
}


/************************************************************************/
/*				ƕɋ܂ꂽ񔲂oiEj			*/
/************************************************************************/
int get_sent_str_rl(char* buf)
{
	return( get_sent_str_sub( buf, 'r', 'l' ) );
}


/************************************************************************/
/*				ƕɋ܂ꂽ񔲂oiEEj			*/
/************************************************************************/
int get_sent_str_rr(char* buf)
{
	return( get_sent_str_sub( buf, 'r', 'r' ) );
}


/************************************************************************/
/*				ƕɋ܂ꂽ񔲂oiTuj			*/
/************************************************************************/
int get_sent_str_sub(char* buf,char first,char second)
{
	
	char first_word[1024];
	char second_word[1024];
	char wrk[4096];
	char wrk2[128];
	char* p_wrk = buf;
	char* start_point;
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, wrk, 0, 4094 );
	delete_doublequotation( wrk );
	
	/* QAR擾 */
	get_comma_lenword( p_wrk, first_word, 1, 1020 );
	delete_doublequotation( first_word );
	get_comma_lenword( p_wrk, second_word, 2, 1020 );
	delete_doublequotation( second_word );
	
	/* SAT擾 */
	get_comma_lenword( p_wrk, wrk2, 3, 126 );
	sscanf( wrk2, " %d", &stack_no );
	get_comma_lenword( p_wrk, wrk2, 4, 126 );
	sscanf( wrk2, " %d", &mode );
	
	/* wŋ܂ꂽӏ */
	if( *first_word == '\0' )start_point = wrk;
	else					 start_point = ( first == 'l' ? strstr( wrk, first_word ) : 
															strrstr( wrk, first_word ) );
	
	if( start_point == NULL ){
		wrk[0] = '\0';
	}
	else{
		strmov( start_point + strlen( first_word ), wrk );
		p_wrk = ( second == 'l' ? strstr( wrk, second_word ) :
								  strrstr( wrk, second_word ) );
		if( *second_word == '\0' );	//㔼w肪ꍇ͂K؂Ȃ
		else if( p_wrk == NULL ){	//㔼w肪Ȃꍇ͓؂
			wrk[0] = '\0';
		}
		else *p_wrk = '\0';		//㔼w畁ʂɂK؂
	}
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, wrk, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				񂩂̈ʒuw蕶؂oij				*/
/************************************************************************/
int get_string_mid(char* buf)
{
	
	char wrk[2048];
	char wrk2[128];
	char* p_wrk = buf;
	int get_start_point = -1;
	int get_end_point = -1;
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	int str_length;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, wrk, 0, 2046 );
	delete_doublequotation( wrk );
	
	/* QAR擾 */
	get_comma_lenword( p_wrk, wrk2, 1, 126 );
	sscanf( wrk2, " %d", &get_start_point );
	get_comma_lenword( p_wrk, wrk2, 2, 126 );
	sscanf( wrk2, " %d", &get_end_point );
	if( get_start_point == -1 || get_end_point == -1 ){
		return(1);	//Ȃ̂ŃG[
	}
	
	/* SAT擾 */
	get_comma_lenword( p_wrk, wrk2, 3, 126 );
	sscanf( wrk2, " %d", &stack_no );
	get_comma_lenword( p_wrk, wrk2, 4, 126 );
	sscanf( wrk2, " %d", &mode );
	
	/* Zbgꂽ̒Ǝ擾ʒu̒sȂ */
	/* i{֐1originłj */
	str_length = strlen( wrk );
	get_start_point--;
	get_end_point--;
	if( get_start_point < 0 )get_start_point = 0;
	if( get_start_point > str_length )get_start_point = str_length;
	if( get_end_point < 0 )get_end_point = 0;
	if( get_end_point > str_length )get_end_point = str_length;
	
	/* o */
	wrk[get_end_point+1] = '\0';
	strmov( &wrk[get_start_point], wrk );
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, wrk, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				񂩂̈ʒuw蕶؂oij				*/
/************************************************************************/
int get_string_left(char* buf)
{
	
	char wrk[2048];
	char wrk2[128];
	char* p_wrk = buf;
	int get_start_point = 1;
	int get_end_point = -1;
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	int str_length;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, wrk, 0, 2046 );
	delete_doublequotation( wrk );
	
	/* Q擾 */
	get_comma_lenword( p_wrk, wrk2, 1, 126 );
	sscanf( wrk2, " %d", &get_end_point );
	if( get_end_point == -1 ){
		return(1);	//Ȃ̂ŃG[
	}
	
	/* RAS擾 */
	get_comma_lenword( p_wrk, wrk2, 2, 126 );
	sscanf( wrk2, " %d", &stack_no );
	get_comma_lenword( p_wrk, wrk2, 3, 126 );
	sscanf( wrk2, " %d", &mode );
	
	/* Zbgꂽ̒Ǝ擾ʒu̒sȂ */
	/* i{֐1originłj */
	str_length = strlen( wrk );
	get_start_point--;
	get_end_point--;
	if( get_start_point < 0 )get_start_point = 0;
	if( get_start_point > str_length )get_start_point = str_length;
	if( get_end_point < 0 )get_end_point = 0;
	if( get_end_point > str_length )get_end_point = str_length;
	
	/* o */
	wrk[get_end_point+1] = '\0';
	strmov( &wrk[get_start_point], wrk );
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, wrk, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				񂩂̈ʒuw蕶؂oiEj				*/
/************************************************************************/
int get_string_right(char* buf)
{
	
	char wrk[2048];
	char wrk2[128];
	char* p_wrk = buf;
	int get_start_point = -1;
	int get_end_point;
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	int str_length;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, wrk, 0, 2046 );
	delete_doublequotation( wrk );
	
	/* Q擾 */
	get_comma_lenword( p_wrk, wrk2, 1, 126 );
	sscanf( wrk2, " %d", &get_start_point );
	if( get_start_point == -1 ){
		return(1);	//Ȃ̂ŃG[
	}
	
	/* RAS擾 */
	get_comma_lenword( p_wrk, wrk2, 2, 126 );
	sscanf( wrk2, " %d", &stack_no );
	get_comma_lenword( p_wrk, wrk2, 3, 126 );
	sscanf( wrk2, " %d", &mode );
	
	/* Zbgꂽ̒Ǝ擾ʒu̒sȂ */
	/* i{֐1originłj */
	str_length = strlen( wrk );
	get_start_point = str_length - get_start_point;
	get_end_point = str_length;
	if( get_start_point < 0 )get_start_point = 0;
	if( get_start_point > str_length )get_start_point = str_length;
	if( get_end_point < 0 )get_end_point = 0;
	if( get_end_point > str_length )get_end_point = str_length;
	
	/* o */
	wrk[get_end_point+1] = '\0';
	strmov( &wrk[get_start_point], wrk );
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, wrk, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*							񒷎擾								*/
/************************************************************************/
int get_string_length(char* buf)
{
	
	char wrk[2048];
	char wrk2[128];
	char* p_wrk = buf;
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, wrk, 0, 2046 );
	delete_doublequotation( wrk );
	
	/* QAR擾 */
	get_comma_lenword( p_wrk, wrk2, 1, 126 );
	sscanf( wrk2, " %d", &stack_no );
	get_comma_lenword( p_wrk, wrk2, 2, 126 );
	sscanf( wrk2, " %d", &mode );
	
	/* 񒷎擾 */
	sprintf( wrk2, "%d", strlen(wrk) );
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, wrk2, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				wt@Cwsǂݍ						*/
/************************************************************************/
int read_file_to_push(char* buf)
{
	
	char* p_wrk;
	char wrk[4096];
	char path[1024];
	int start_no = 0;
	int end_no = 0;
	
	/* 擾 */
	if( getarg_str_num_num( buf, wrk, &start_no, &end_no ) != 0 )return(1);
	if( start_no != 0 )start_no--;
	if( end_no != 0   )end_no--;
	
	/* t@C".\""..\"݂ꍇ͎gpsƂ */
	p_wrk = strstr( wrk, ".\\" );
	if( p_wrk != NULL ){
		/* gpsȂ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* w肳ꂽt@C̃tpX쐬 */
	strcpy( path, GlobalPath );
	wrk[1023-strlen(path)] = '\0';//߂΍
	strcat( path, wrk );
	
	/* t@C̗L擾 */
	if( access( path, 0 ) != 0 ){
		/* wt@C݂Ȃ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* t@CI[v */
	FILE* fp = fopen( path, "rt" );
	if( fp == NULL ){
		/* wt@Cǂ߂Ȃ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* wsǂݍ */
	int loop_cnt;
	for( loop_cnt = start_no; loop_cnt <= end_no; loop_cnt++ ){
		/* Psǂݍ݁{s */
		if( fgets( wrk, 4090, fp ) == NULL )break;
		p_wrk = strchr( wrk, '\n' );
		if( p_wrk != NULL )*p_wrk = '\0';
		
		/* YJ */
		free_target_paragraph( loop_cnt );
		
		/* 񂪂OoCg̎̓mۂȂ */
		if( wrk[0] == '\0' )continue;
		
		/* mۂĕRs[ */
		if( ( GStack[loop_cnt] = (char*)malloc( strlen(wrk)+1 )) != NULL ){
			/* eRs[ */
			strcpy( GStack[loop_cnt], wrk );
		}
		else{
			/* mێs */
			GStack[loop_cnt] = NULL;
		}
	}
	
	/* t@C */
	fclose(fp);
	
	/* ֐ */
	remove_function( buf );
	
	return(0);
}


/************************************************************************/
/*				wt@CɎwsoiVKoj			*/
/************************************************************************/
int write_file_from_pop(char* buf)
{
	return( write_file_from_pop_sub( buf, 0 ) );
}


/************************************************************************/
/*				wt@CɎwsoiǉoj			*/
/************************************************************************/
int write_file_from_pop_app(char* buf)
{
	return( write_file_from_pop_sub( buf, 1 ) );
}


/************************************************************************/
/*				wt@CɎwso							*/
/************************************************************************/
int write_file_from_pop_sub(char* buf,int flg)
{
	
	char* p_wrk;
	char wrk[4096];
	char path[1024];
	int start_no = 0;
	int end_no = 0;
	
	/* 擾 */
	if( getarg_str_num_num( buf, wrk, &start_no, &end_no ) != 0 )return(1);
	if( start_no != 0 )start_no--;
	if( end_no != 0   )end_no--;
	
	/* t@C".\""..\"݂ꍇ͎gpsƂ */
	p_wrk = strstr( wrk, ".\\" );
	if( p_wrk != NULL ){
		/* gpsȂ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* w肳ꂽt@C̃tpX쐬 */
	strcpy( path, GlobalPath );
	wrk[1023-strlen(path)] = '\0';//߂΍
	strcat( path, wrk );
	
	/* t@CI[v */
	FILE* fp;
	if( flg == 0 )fp = fopen( path, "wt" );
	else		  fp = fopen( path, "at" );
	
	if( fp == NULL ){
		/* wt@CJȂ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* ws */
	int loop_cnt;
	for( loop_cnt = start_no; loop_cnt <= end_no; loop_cnt++ ){
		if( GStack[loop_cnt] != NULL ){
			fprintf( fp, "%s\n", GStack[loop_cnt] );
		}
		else{
			fprintf( fp, "\n" );
		}
	}
	
	/* t@C */
	fclose(fp);
	
	/* ֐ */
	remove_function( buf );
	
	return(0);
}


/************************************************************************/
/*				쐬											*/
/************************************************************************/
int set_random_num(char* buf)
{
	
	char wrk[256];
	char* p_wrk;
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	long min_num;
	long max_num;
	
	/* PAQ擾 */
	p_wrk = strchr( buf, '(' );
	if( p_wrk == NULL )return(1);
	if( sscanf( p_wrk+1, " %ld , %ld", &min_num, &max_num ) < 2 )return(1);	//ȉ߂

	/* RAS擾 */
	p_wrk = strchr( buf, ',' );
	if( p_wrk == NULL )return(1);	//','̂͂
	get_last2arg( p_wrk+1, &stack_no, &mode );
	
	/* 쐬 */
	long get_num = (long)get_rnd_num( (unsigned long)(max_num-min_num+1) );
	get_num += (unsigned long)min_num-1;
	sprintf(wrk, "%ld", get_num );
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack( buf, wrk, stack_no, mode);

	return(0);
}


/************************************************************************/
/*				߂̕A											*/
/************************************************************************/
int set_paragraph(char* buf)
{
	char* p_wrk;
	int stack_no = 0;
	
	/* oX^bNǂݍ */
	p_wrk = buf;
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	if( sscanf( p_wrk, "%d", &stack_no ) != 1 )return(1);
	if( stack_no > PUSH_NUM )		stack_no = 0;
	else if( stack_no < 1 )	stack_no = 0;
	else					stack_no--;		/* ł0` */

	/* ܂폜 */
	remove_function( buf );
	
	/* } */
	if( GStack[stack_no] != NULL ){
		strmov( buf, buf+strlen(GStack[stack_no]) );
		memcpy( buf, GStack[stack_no], strlen(GStack[stack_no]) );
	}

	return(0);
}


/************************************************************************/
/*				̂܂܏óiʂȎʎqnŗLj			*/
/************************************************************************/
int set_string(char* buf)
{
	char wrk[4096];
	char* p_wrk = buf;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* 擾 */
	get_comma_lenword( p_wrk, wrk, 0, 4094 );
	delete_doublequotation( wrk );
	
	/* ܂폜 */
	remove_function( buf );
	
	/* } */
	strmov( buf, buf+strlen(wrk) );
	memcpy( buf, wrk, strlen(wrk) );
	
	return(0);
}


/************************************************************************/
/*				COMMUNICATEpL[[hZbg						*/
/************************************************************************/
int set_reflect(char* buf)
{
	
	char ghost[1024];
	char arg_str[1024];
	char* p_wrk;
	char* p_wrk2;
	char* input_buf = GStack[PUSH_EVENT_ALLSENTENCE];
	unsigned int loop_cnt;
	unsigned int len = strlen(buf);
	unsigned int arg_point = 0;
	int flg = 0;
	int arg_no = 0;
	
	/* O[õt@XGANA */
	for( loop_cnt = 0; loop_cnt < 8; loop_cnt++ )GReference[loop_cnt][0] = '\0';
	
	/* [J̃S[XgGANA */
	ghost[0] = '\0';
	
	/* ֐"("PoCg`FbN */
	loop_cnt = 0;
	while( *(buf+loop_cnt) != '(' )loop_cnt++;
	loop_cnt++;
	for( ; loop_cnt < len; loop_cnt++ ){
		/* ֐I[𔭌`FbNI */
		if( *(buf+loop_cnt) == ')' && flg == 0 )break;
		
		/* _uNH[e[V`FbN */
		if( *(buf+loop_cnt) == '\"' ){
			if( flg == 0 ){
				/*  */
				flg = 1;
				arg_point = 0;
				continue;
			}
			else{
				/* o */
				flg = 0;
				arg_str[arg_point] = '\0';
				if( arg_no == 0 )strcpy( ghost, arg_str );
				else			 strcpy( GReference[arg_no-1], arg_str );
				arg_no++;
				continue;
			}
		}
		
		/* NH[e[V */
		if( flg == 1 ){
			arg_str[arg_point] = *(buf+loop_cnt);
			arg_point++;
			continue;
		}
		
		/* iȍ~͕KNH[e[VOłj */
		
		/* J}`FbN */
		if( *(buf+loop_cnt) == ',' ){
			if( *(buf+loop_cnt-1) == ',' || *(buf+loop_cnt-1) == '(' ){
				/* ȗĂ̂ŒO̕YӏɃZbg */
				if( arg_no == 0 )ghost[0] = '\0';
				else			 GReference[arg_no-1][0] = '\0';
				arg_no++;
				continue;
			}
		}
	}
	
	/* bԓňقȂ */
	p_wrk  = strstr( input_buf, "GET Sentence SHIORI/2.3[13][10]Sender: " );
	p_wrk2 = strstr( input_buf, "Age: " );
	if( p_wrk != NULL && p_wrk2 != NULL ){
		/* ԓ */
		/* Age擾{CNg */
		sscanf( p_wrk2, "Age: %d", &GSendAge );
		GSendAge++;
		
		/* S[Xgw肳Ă邩 */
		if( ghost[0] != '\0' ){
			/* w肳Ă̂łɘbU */
			strcpy( GSendGhostName, ghost );
		}
		else{
			/* w肳ĂȂ̂Ō̑ */
			memcpy( ghost, input_buf+strlen("GET Sentence SHIORI/2.3[13][10]Sender: "), 1020 );
			p_wrk = strstr( ghost, "[13][10]" );
			if( p_wrk != NULL ){
				*p_wrk = '\0';
				strcpy( GSendGhostName, ghost );
			}
			else GSendGhostName[0] = '\0';
		}
		
	}
	else{
		/* b */
		/* Age */
		GSendAge = 0;
		
		/* S[Xgw肳Ă邩 */
		if( ghost[0] != '\0' ){
			/* w肳Ă̂łɘb */
			strcpy( GSendGhostName, ghost );
		}
		else{
			/* w肳ĂȂ̂ő_ɑI */
			/* Ȃꍇ͔b */
			if( GOtherGhostNum == 0 )GSendGhostName[0] = '\0';
			/* S[Xg擾 */
			else strcpy( GSendGhostName, GOtherGhostName[get_rnd_num(GOtherGhostNum)-1] );
		}
	}
	
	/* ֐폜 */
	remove_function( buf );
	
	return(0);
}


/************************************************************************/
/*				f											*/
/************************************************************************/
int chk_ifelse(char* buf)
{

	char* p_delstartfnc;
	char* p_delendfnc;
	char* p_chk;
	char* p_nextelse;
	int type;

	/* ŏ$IF𔻒f */
	if( chk_if_sub(buf) ){
		/* ^ */
		log_write_user( "IF͐^ł", "ese_Ifanl.log", GDBGIfAnalysis );
		log_write_user( buf, "ese_Ifanl.log", GDBGIfAnalysis );
		
		/* Ήŏ$ELSEIFA$ELSEA$ENDIFT */
		p_delstartfnc = next_elseendif( buf, &type );
		log_write_user( "p_delstartfnc", "ese_Ifanl.log", GDBGIfAnalysis );
		log_write_user( p_delstartfnc, "ese_Ifanl.log", GDBGIfAnalysis );
		
		/* $ELSEIFA$ELSȄꍇ͑Ή$ENDIFT */
		if( type == TYPE_ELSEIF || type == TYPE_ELSE ){
			p_delendfnc = last_endif( buf );
			log_write_user( "p_delendfnc", "ese_Ifanl.log", GDBGIfAnalysis );
			log_write_user( p_delendfnc, "ese_Ifanl.log", GDBGIfAnalysis );
		}
		
		/* ͈͊O */
		if( p_delstartfnc == NULL );	//$IF݂̂̌`i͈͂̓iCj
		else if( type == TYPE_ENDIF )remove_function(p_delstartfnc);
										//$IF`$ENDIF`i$ENDIF̂ݏj
		else if( p_delendfnc == NULL )*p_delstartfnc = '\0';
										//$IF`$ELSE(IF)`i$ELSEŐ؂j
		else{
			remove_function(p_delendfnc);
			strmov( p_delendfnc, p_delstartfnc );
										//$IF`$ELSE(IF)`$ENDIF`
										//i$ENDIFȍ~Rs[$ELSEɏ㏑j
		}
		
		/* $IF */
		log_write_user( buf, "ese_Ifanl.log", GDBGIfAnalysis );
		remove_function(buf);
		log_write_user( buf, "ese_Ifanl.log", GDBGIfAnalysis );
		return(0);
	}

	/* ŏ$IFUȂ̂ňȍ~Ή$ELSEIFƂ`FbN */
	p_chk = buf;
	while( ( p_nextelse=next_elseendif(p_chk,&type)) != NULL ){

		log_write_user( "IF͐^ł͂Ȃ", "ese_Ifanl.log", GDBGIfAnalysis );
		log_write_user( buf, "ese_Ifanl.log", GDBGIfAnalysis );
		log_write_user( p_nextelse, "ese_Ifanl.log", GDBGIfAnalysis );

		/* $ELSEꍇ$ELSEȍ~$ENDIF܂ŎcAȊOďI */
		if( type == TYPE_ELSE ){
			p_delendfnc = last_endif( buf );
			if( p_delendfnc != NULL )remove_function(p_delendfnc);
										//$ENDIFΏ

			remove_function(p_nextelse);
			strmov( p_nextelse, buf );
										//$ELSEȍ~$IFɏ㏑i=IF`ELSEԏj
			return(0);
		}
		
		/* $ENDIF̏ꍇ$IFSĂďI */
		if( type == TYPE_ENDIF ){

			remove_function(p_nextelse);//$ENDIF
			strmov( p_nextelse, buf );
										//$ELSEȍ~$IFɏ㏑i=IF`ELSEԏj
			return(0);
		}
		
		/* $ELSEIF̏ꍇ͑Đ^UsȂ */
		/* ʎqϊ */
		chg_pop_to_str(p_nextelse);
		if( chk_if_sub(p_nextelse) ){
			/* ^̂ł̑鏈sȂ */
			/* ܂$IF`Y$ELSEIF܂ł */
			strmov( p_nextelse, buf );
			
			/* ȍ~$IFƓ */
			/* Ή鎟ELSE,ELSEIF,ENDIFT */
			p_delstartfnc = next_elseendif( buf, &type );
			
			log_write_user( "\nnext else,elseif,endif", "ese_Ifanl.log", GDBGIfAnalysis );
			log_write_user( p_delstartfnc, "ese_Ifanl.log", GDBGIfAnalysis );
			
			/* $ELSEIFA$ELSȄꍇ͑Ή$ENDIFT */
			if( type == TYPE_ELSEIF || type == TYPE_ELSE ){
				p_delendfnc = last_endif( buf );
				log_write_user( "\nlast endif", "ese_Ifanl.log", GDBGIfAnalysis );
				log_write_user( p_delendfnc, "ese_Ifanl.log", GDBGIfAnalysis );
			}
			
			/* ͈͊O */
			if( p_delstartfnc == NULL );	//$ELSEIF݂̂̌`i͈͂̓iCj
			else if( type == TYPE_ENDIF )remove_function(p_delstartfnc);
											//$ELSEIF`$ENDIF`i$ENDIF̂ݏj
			else if( p_delendfnc == NULL )*p_delstartfnc = '\0';
											//$ELSEIF`$ELSE(IF)`i$ELSEŐ؂j
			else{
				remove_function( p_delendfnc );
				strmov( p_delendfnc, p_delstartfnc );
											//$ELSEIF`$ELSE(IF)`$ENDIF`
											//i$ENDIFȍ~Rs[$ELSEɏ㏑j
			}
			
			/* g(ELSEIF) */
			remove_function( buf );
			
			return(0);
			
		}
		else{
			/* ELSEIFÛŎ */
			p_chk = p_nextelse+1;
		}
	}
	
	/* ŏIFUŁAȍ~iCorȍ~ELSEIFSċUAENDIFꍇ */
	*buf = '\0';
	
	return(0);
	

}


/************************************************************************/
/*	X^[gʒu猩ΉELSE,ELSEIF,ENDIFtAނƈʒuԂ	*/
/************************************************************************/
char* next_elseendif( char* buf, int* type )
{
	int loop_cnt;
	int len;
	int flg = 0;
	
	len = strlen(buf);
	
	/* PoCgTčs */
	for( loop_cnt = 1; loop_cnt < len; loop_cnt++ ){
		if( *(buf+loop_cnt) != '$' )continue;
		
		if( memlcmp( buf+loop_cnt, "$IF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$_IF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$__IF" ) == 0 ){
			flg++;
			continue;
		}
		if( memlcmp( buf+loop_cnt, "$ELSEIF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$_ELSEIF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$__ELSEIF" ) == 0 ){
			if( flg == 0 ){
				*type = TYPE_ELSEIF;
				return(buf+loop_cnt);
			}
			else continue;
		}
		if( memlcmp( buf+loop_cnt, "$ELSE" ) == 0 ||
			memlcmp( buf+loop_cnt, "$_ELSE" ) == 0 ||
			memlcmp( buf+loop_cnt, "$__ELSE" ) == 0 ){
			if( flg == 0 ){
				*type = TYPE_ELSE;
				return(buf+loop_cnt);
			}
			else continue;
		}
		if( memlcmp( buf+loop_cnt, "$ENDIF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$_ENDIF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$__ENDIF" ) == 0 ){
			if( flg == 0 ){
				*type = TYPE_ENDIF;
				return(buf+loop_cnt);
			}
			else{
				flg--;
				continue;
			}
		}
	}
	
	/* tȂ̂NULLԂ */
	*type = TYPE_NO;
	return(NULL);
	
}


/************************************************************************/
/*				X^[gʒu猩ΉENDIFt					*/
/************************************************************************/
char* last_endif( char* buf )
{
	int loop_cnt;
	int len;
	int flg = 0;
	
	len = strlen(buf);
	
	/* PoCgTčs */
	for( loop_cnt = 1; loop_cnt < len; loop_cnt++ ){
		if( *(buf+loop_cnt) != '$' )continue;
		
		if( memlcmp( buf+loop_cnt, "$IF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$_IF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$__IF" ) == 0 ){
			flg++;
			continue;
		}
		if( memlcmp( buf+loop_cnt, "$ENDIF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$_ENDIF" ) == 0 ||
			memlcmp( buf+loop_cnt, "$__ENDIF" ) == 0 ){
			if( flg == 0 ){
				return(buf+loop_cnt);
			}
			else{
				flg--;
				continue;
			}
		}
	}
	
	/* tȂ̂NULLԂ */
	return(NULL);
	
}


/************************************************************************/
/*				f											*/
/************************************************************************/
int chk_if_sub(char* buf)
{

#define IF_E  1
#define IF_NE 2
#define IF_A  3
#define IF_AE 4
#define IF_B  5
#define IF_BE 6
	
	char left[1024];
	char right[1024];
	long leftl;
	long rightl;
	int loop_cnt;
	int len = strlen(buf);
	int flg = 0;
	int arg_no = 0;
	int arg_point;
	int judge = 0;
	int ret_cd;
	
	/*  */
	loop_cnt = 0;
	while( *(buf+loop_cnt) != '(' )loop_cnt++;
	loop_cnt++;
	
	/* 񂩐 */
	while( *(buf+loop_cnt) != '\"' && *(buf+loop_cnt) != '-' && 
			( *(buf+loop_cnt) > '9' || *(buf+loop_cnt) < '0') )loop_cnt++;
	
	log_write_user( "Jn", "ese_Ifanl.log", GDBGIfAnalysis );
	log_write_user( buf+loop_cnt, "ese_Ifanl.log", GDBGIfAnalysis );
	
	/* ̏ꍇ */
	if( *(buf+loop_cnt) == '\"' ){
		for( ; loop_cnt < len; loop_cnt++ ){
			/* _uNH[e[V`FbN */
			if( *(buf+loop_cnt) == '\"' ){
				if( flg == 0 ){
					/*  */
					flg = 1;
					arg_point = 0;
					continue;
				}
				else{
					/* o */
					flg = 0;
					( arg_no == 0 ? *(left+arg_point) : *(right+arg_point) ) = '\0';
					arg_no++;
					continue;
				}
			}
			
			/* NH[e[V */
			if( flg == 1 ){
				( arg_no == 0 ? *(left+arg_point) : *(right+arg_point) ) = *(buf+loop_cnt);
				arg_point++;
				continue;
			}
			/* iȍ~͕KNH[e[VOłj */
			
			/* q擾 */
			if( *(buf+loop_cnt) == '=' || 
				*(buf+loop_cnt) == '>' || 
				*(buf+loop_cnt) == '<'   ){
				if( memlcmp( buf+loop_cnt, "><" ) == 0 )judge = IF_NE;
				else if( memlcmp( buf+loop_cnt, "<>" ) == 0 )judge = IF_NE;
				else if( memlcmp( buf+loop_cnt, ">=" ) == 0 )judge = IF_AE;
				else if( memlcmp( buf+loop_cnt, "=>" ) == 0 )judge = IF_AE;
				else if( memlcmp( buf+loop_cnt, "<=" ) == 0 )judge = IF_BE;
				else if( memlcmp( buf+loop_cnt, "=<" ) == 0 )judge = IF_BE;
				else if( memlcmp( buf+loop_cnt, "=" ) == 0 )judge = IF_E;
				else if( memlcmp( buf+loop_cnt, ">" ) == 0 )judge = IF_A;
				else if( memlcmp( buf+loop_cnt, "<" ) == 0 )judge = IF_B;
				if( judge == IF_NE || judge == IF_AE || judge == IF_BE )loop_cnt++;
				continue;
			}
			
			/* ʕŏI */
			if( *(buf+loop_cnt) == ')' )break;
			
		}
	}
	/* ̏ꍇ */
	else{
		arg_point = 0;
		arg_no = 0;
		for( ; loop_cnt < len; loop_cnt++ ){
			/* 擾 */
			if( *(buf+loop_cnt) >= '0' && *(buf+loop_cnt) <= '9' || *(buf+loop_cnt) == '-' ){
				( arg_no == 0 ? *(left+arg_point) : *(right+arg_point) ) = *(buf+loop_cnt);
				arg_point++;
				continue;
			}
			
			/* q擾 */
			if( *(buf+loop_cnt) == '>' || 
				*(buf+loop_cnt) == '<' || 
				*(buf+loop_cnt) == '=' ){
				if( memlcmp( buf+loop_cnt, "><" ) == 0 )judge = IF_NE;
				else if( memlcmp( buf+loop_cnt, "<>" ) == 0 )judge = IF_NE;
				else if( memlcmp( buf+loop_cnt, ">=" ) == 0 )judge = IF_AE;
				else if( memlcmp( buf+loop_cnt, "=>" ) == 0 )judge = IF_AE;
				else if( memlcmp( buf+loop_cnt, "<=" ) == 0 )judge = IF_BE;
				else if( memlcmp( buf+loop_cnt, "=<" ) == 0 )judge = IF_BE;
				else if( memlcmp( buf+loop_cnt, "=" ) == 0 )judge = IF_E;
				else if( memlcmp( buf+loop_cnt, ">" ) == 0 )judge = IF_A;
				else if( memlcmp( buf+loop_cnt, "<" ) == 0 )judge = IF_B;
				if( judge == IF_NE || judge == IF_AE || judge == IF_BE )loop_cnt++;
				
				/* i߂ */
				( arg_no == 0 ? *(left+arg_point) : *(right+arg_point) ) = '\0';
				arg_point = 0;
				arg_no++;
				continue;
			}
			
			/* ʕŏI */
			if( *(buf+loop_cnt) == ')' )break;
		}
	}
	
	log_write_user( "", "ese_Ifanl.log", GDBGIfAnalysis );
	log_write_user( left, "ese_Ifanl.log", GDBGIfAnalysis );
	log_write_user( "E", "ese_Ifanl.log", GDBGIfAnalysis );
	log_write_user( right, "ese_Ifanl.log", GDBGIfAnalysis );
	
	/* ^[R[h */
	ret_cd = 0;
	
	/* Ȃ琔ɕϊĂ画肷 */
	if( sscanf( left, "%ld", &leftl ) == 1 &&
		sscanf( right,"%ld", &rightl) == 1 ){
		/* ƂĔ */
		switch( judge ){
			case IF_E:	ret_cd = ( leftl == rightl );break;
			case IF_NE:	ret_cd = ( leftl != rightl );break;
			case IF_A:	ret_cd = ( leftl > rightl );break;
			case IF_AE:	ret_cd = ( leftl >= rightl );break;
			case IF_B:	ret_cd = ( leftl < rightl );break;
			case IF_BE:	ret_cd = ( leftl <= rightl );break;
		}
	}
	else{
		/* ƂĔ */
		switch( judge ){
			case IF_E:	ret_cd = ( strcmp( left, right ) == 0 );break;
			case IF_NE:	ret_cd = ( strcmp( left, right) != 0 );break;
			case IF_A:	ret_cd = ( strcmp( left, right) > 0 );break;
			case IF_AE:	ret_cd = ( strcmp( left, right) >= 0 );break;
			case IF_B:	ret_cd = ( strcmp( left, right) < 0 );break;
			case IF_BE:	ret_cd = ( strcmp( left, right) <= 0 );break;
		}
	}
	
	return(ret_cd);
	
}


/************************************************************************/
/*				OMϊ											*/
/************************************************************************/
int change_gurongi(char* buf)
{
	
	char last_char[10];
	char wrk[1024];
	char wrk2[1024];
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	
	/* 擾 */
	if( getarg_str_num_num( buf, wrk, &stack_no, &mode ) != 0 ){
		return(1);
	}
	
	/* OMϊ */
	int len = strlen( wrk );
	int len1;
	int len2;
	int loop_cnt;
	int loop_cnt2;
	
	/* ܂ŏɑSЉ𕽉ɕϊ */
	for( loop_cnt = 0; loop_cnt < len; loop_cnt++ ){
		if( wrk[loop_cnt] == '\0' )break;
		
		/* QoCgȊO͉Ȃ */
		if( !multi_byte_chk( (int)wrk[loop_cnt] ) )continue;
		
		/* Љ͕ɕϊ */
		chg_kata_to_hira( (unsigned char *)&wrk[loop_cnt] );
		
	}
	
	/* PoCg`FbN */
	for( loop_cnt = 0; loop_cnt < len; loop_cnt++ ){
		if( wrk[loop_cnt] == '\0' )break;
		
		/* QoCgȊO͉Ȃ */
		if( !multi_byte_chk( (int)wrk[loop_cnt] ) )continue;
		
		/* ͕ʏ */
		if( memlcmp( &wrk[loop_cnt], "[" ) == 0 && loop_cnt > 1 ){
			strcpy( wrk2, &wrk[loop_cnt+2] );
			strcpy( &wrk[loop_cnt], last_char );
			strcat( wrk, wrk2 );
			continue;
		}
		
		/* e[u`FbN */
		for( loop_cnt2 = 0; ; loop_cnt2++ ){
			
			/* ^[~l[^H */
			if( *(GStrGurongiDic[loop_cnt2].moto) == '\0' )break;
			
			/* vH */
			if( memlcmp( &wrk[loop_cnt], GStrGurongiDic[loop_cnt2].moto ) == 0 ){
			
				/* ϊOAϊ̕񒷂擾 */
				len1 = strlen(GStrGurongiDic[loop_cnt2].moto);
				len2 = strlen(GStrGurongiDic[loop_cnt2].sue);
				
				/* ȂPɃRs[邾iԒZkj */
				if( len1 == len2 ){
					memcpy( &wrk[loop_cnt], GStrGurongiDic[loop_cnt2].sue, len2 );
				}
				/* ႤȂޔČ */
				else{
					strcpy( wrk2, &wrk[loop_cnt+len1] );
					strcpy( &wrk[loop_cnt], GStrGurongiDic[loop_cnt2].sue );
					strcat( wrk, wrk2 );
				}
				loop_cnt += len2-1;
				len += len2 - len1;
				strcpy( last_char, GStrGurongiDic[loop_cnt2].sue );
				break;
			}
		}
	}
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, wrk, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				lZ												*/
/************************************************************************/
int calc(char* buf)
{
#define CALC_ADD		1
#define CALC_SUB		2
#define CALC_MULTI		3
#define CALC_DIV		4
#define CALC_DIV_REM	5
	

	char wrk[128];
	char left[128];
	char right[128];
	long leftl;
	long rightl;
	long result;
	int loop_cnt;
	int calc_flg;
	int len = strlen(buf);
	int flg = 0;
	int arg_no = 0;
	int arg_point;
	int stack_no = 0;
	int mode = PARAGRAPH_VISIBLE;
	
	/*  */
	for( loop_cnt = 0; loop_cnt < len; loop_cnt++ ){
		/* _uNH[e[V`FbN */
		if( *(buf+loop_cnt) == '\"' ){
			if( flg == 0 ){
				/*  */
				flg = 1;
				arg_point = 0;
				continue;
			}
			else{
				/* o */
				flg = 0;
				( arg_no == 0 ? left[arg_point] : right[arg_point] ) = '\0';
				arg_no++;
				continue;
			}
		}
		
		/* NH[e[V */
		if( flg == 1 ){
			if( arg_point < 128 ){
				( arg_no == 0 ? left[arg_point] : right[arg_point] ) = *(buf+loop_cnt);
				arg_point++;
			}
			continue;
		}
		/* iȍ~͕KNH[e[VOłj */
		
		/* q擾 */
		if( *(buf+loop_cnt) == '+' ){
			calc_flg = CALC_ADD;
			continue;
		}
		if( *(buf+loop_cnt) == '-' ){
			calc_flg = CALC_SUB;
			continue;
		}
		if( *(buf+loop_cnt) == '*' ){
			calc_flg = CALC_MULTI;
			continue;
		}
		if( *(buf+loop_cnt) == '/' ){
			calc_flg = CALC_DIV;
			continue;
		}
		if( *(buf+loop_cnt) == '%' ){
			calc_flg = CALC_DIV_REM;
			continue;
		}
		
		/* Sȍ~CɃ`FbN */
		if( arg_no == 2 ){
			get_last2arg( buf+loop_cnt, &stack_no, &mode );
			break;
		}
		
		/* ʕŏIiɂ͗ȂnYj */
		if( *(buf+loop_cnt) == ')' )break;
		
	}
	
	/* 𐔎ɕϊ */
	if( sscanf( left, "%ld", &leftl ) != 1 )leftl = 0;
	if( sscanf( right,"%ld", &rightl) != 1 )rightl = 0;
	
	/* vZ */
	switch( calc_flg ){
		case CALC_ADD:
			result = leftl + rightl;
			break;
		case CALC_SUB:
			result = leftl - rightl;
			break;
		case CALC_MULTI:
			result = leftl * rightl;
			break;
		case CALC_DIV:
			if( rightl != 0 )result = leftl / rightl;
			else			 result = 99999999;
			break;
		case CALC_DIV_REM:
			if( rightl != 0 )result = leftl % rightl;
			else			 result = 0;
			break;
		default :
			result = 0;
	}
	
	/* ɕϊ */
	sprintf( wrk, "%ld", result );
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, wrk, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				_g[NԊuݒ菈								*/
/************************************************************************/
int talk_interval(char* buf)
{
	
	long interval;
	long flg;
	
	int ret = sscanf( buf, "$TALK_INTERVAL( %ld , %ld", &interval, &flg );
	
	if( ret == 0 ){
		/* ݒ~XȂ̂ŉȂ */
		return(1);
	}
	else if( ret == 1 ){
		/* QȗiꎞIݒƌȂj */
		GRandomTalkCount = interval;
	}
	else{
		if( flg == 0 ){
			/* ꎞIݒ */
			GRandomTalkCount = interval;
		}
		else{
			/* PvIݒ */
			GRandomTalkCountMax = GRandomTalkCount = interval;
			
			/* t@Cɂo */
			char wrk[64];
			sprintf( wrk, "%ld", GRandomTalkCountMax );
			WritePrivateProfileString( "ESEAI", "RANDOM_TALK_INTERVAL", wrk, GProFile );
		}
	}
	
	remove_function(buf);
	
	return(0);
	
}


/************************************************************************/
/*				j[Xǂݏ										*/
/************************************************************************/
int read_news(char* buf)
{
	
	char wrk[4096];
	char path[1024];
	char* p_wrk;
	int stack_no = 1;
	int mode = PARAGRAPH_VISIBLE;
	int last = 0;
	
	/* 擾 */
	if( getarg_str_num_num( buf, wrk, &stack_no, &mode ) != 0 )return(1);
	
	/* t@C".\""..\"݂ꍇ͎gpsƂ */
	p_wrk = strstr( wrk, ".\\" );
	if( p_wrk != NULL ){
		/* gpsȂ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* w肳ꂽt@C̃tpX쐬 */
	strcpy( path, GlobalPath );
	strcat( path, wrk );
	
	/* t@C̗L擾 */
	if( access( path, 0 ) != 0 ){
		/* wt@C݂Ȃ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* ǂނׂs擾 */
	unsigned int line = GetPrivateProfileInt( "ESEAI_NEWS", wrk, 0, GProFile );
	
	/* j[Xt@CI[v */
	FILE* fp = fopen( path, "rt" );
	if( fp == NULL ){
		/* wt@Cǂ߂Ȃ̂Ŋ֐ďI */
		remove_function( buf );
		return(0);
	}
	
	/* t@Cޔ */
	strcpy( path, wrk );
	
	/* PsڂTNwb_ǂ */
	if( fgets( wrk, 4090, fp ) != NULL ){
		/* TNwb_ȊO擪ǂށiTNwb_ǂݔ΂j */
		if( memlcmp( wrk, "[SAKURA]" ) != 0 )fseek( fp, 0, SEEK_SET );
	}
	
	/* Ys܂łPsǂ݂Ȃ烋[v */
	unsigned int loop_cnt;
	for( loop_cnt = 0; loop_cnt < line; loop_cnt++ ){
		if( fgets( wrk, 4090, fp ) == NULL )break;
	}
	if( loop_cnt == line ){
		if( fgets( wrk, 4090, fp ) == NULL ){
			/* j[Xt@C̍sȂ̂ŉȂ */
			wrk[0] = '\0';
			last = 1;
		}
		else{
			/* ǂݏos̍ŌɕtĂsR[h폜 */
			char* p_wrk = strchr( wrk, '\n' );
			if( p_wrk != NULL )*p_wrk = '\0';
		}
	}
	else{
		/* j[Xt@C̍sȂ̂ŉȂ */
		wrk[0] = '\0';
		last = 1;
	}
	
	/* t@C */
	fclose(fp);
	
	/* ǂݏoꍇ͓ǂݏosCNgĕۑ */
	if( last == 0 ){
		line++;
		char wrk2[16];
		sprintf( wrk2, "%ld", line );
		WritePrivateProfileString( "ESEAI_NEWS", path, wrk2, GProFile );
	}
	
	/* ɏ]ďiLyъ֐Euj */
	set_stack(buf, wrk, stack_no, mode);
	
	return(0);
	
}


/************************************************************************/
/*				j[Xǂ݊Ԋuݒ菈								*/
/************************************************************************/
int news_interval(char* buf)
{
	
	long interval;
	long flg;
	
	/* lǂݍ */
	int ret = sscanf( buf, "$NEWS_INTERVAL( %ld , %ld", &interval, &flg );
	if( ret == 0 ){
		/* ݒ~XȂ̂ŉȂ */
		return(1);
	}
	else if( ret == 1 ){
		/* QȗiꎞIݒƌȂj */
		GNewsReadCount = interval;
	}
	else{
		if( flg == 0 ){
			/* ꎞIݒ */
			GNewsReadCount = interval;
		}
		else{
			/* PvIݒ */
			GNewsReadCountMax = GNewsReadCount = interval;
			
			/* t@Cɂo */
			char wrk[64];
			sprintf( wrk, "%ld", GNewsReadCountMax );
			WritePrivateProfileString( "ESEAI", "NEWS_READ_INTERVAL", wrk, GProFile );
		}
	}
	
	remove_function(buf);
	
	return(0);
	
}


/************************************************************************/
/*				j[Xǂ݃JEg蓮ݒ菈						*/
/************************************************************************/
int set_news_count(char* buf)
{
	
	long interval;
	char news_name[1024];
	char* p_wrk;
	char* p_wrk2;
	
	/* j[Xt@C擾 */
	p_wrk = strchr( buf, '\"' );
	if( p_wrk == NULL )return(1);
	memcpy( news_name, p_wrk+1, 1020 );
	p_wrk2 = strchr( news_name, '\"' );
	if( p_wrk2 == NULL )return(1);
	*p_wrk2 = '\0';
	
	/* JE^擾 */
	p_wrk2 = strchr( p_wrk, '\"' );
	if( p_wrk2 == NULL )return(1);
	if( sscanf( p_wrk2+1, " , %ld", &interval ) != 1 )interval = 0;
	
	/* JE^eo */
	char wrk[64];
	sprintf( wrk, "%ld", interval );
	WritePrivateProfileString( "ESEAI_NEWS", news_name, wrk, GProFile );
	
	/* ֐폜 */
	remove_function(buf);
	
	return(0);
	
}


/************************************************************************/
/*				wb_R[h蓮ݒ菈								*/
/************************************************************************/
int set_header_code(char* buf)
{
	
	long code;
	
	/* lǂݍ */
	int ret = sscanf( buf, "$MKHEADER( %ld", &code );
	if( ret == 0 ){
		/* ݒ~XȂ̂ŉȂ */
		return(1);
	}
	
	/* Zbgꂽlwb_R[hƂ */
	GHeadCode = (int)code;
	
	/* ֐폜 */
	remove_function(buf);
	
	return(0);
	
}


/************************************************************************/
/*				Ggf[^ǉ									*/
/************************************************************************/
int set_entry_data(char* buf)
{
	return( acc_entry_data(buf,USER_DIC_SET) );
}


/************************************************************************/
/*				Ggf[^폜									*/
/************************************************************************/
int del_entry_data(char* buf)
{
	return( acc_entry_data(buf,USER_DIC_DEL) );
}


/************************************************************************/
/*				Ggf[^ǉE폜							*/
/************************************************************************/
int acc_entry_data(char* buf,int acc_flg)
{
	
	char entry[136];
	char word[1030];
	char filename[1030];
	char wrk[1030];
	char* p_wrk = buf;
	int loop_cnt;
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾iGgj */
	get_comma_lenword( p_wrk, entry, 0, 134 );
	delete_doublequotation( entry );
	
	/* Q擾i[hj */
	get_comma_lenword( p_wrk, word, 1, 1024 );
	delete_doublequotation( word );
	
	/* R擾ioj */
	get_comma_lenword( p_wrk, wrk, 2, 1024 );
	delete_doublequotation( wrk );
	if( wrk[0] == '\0' ){
		strcpy( filename, GUserDicFile );
	}
	else{
		strcpy( filename, GlobalPath );
		strcat( filename, wrk );
	}
	
	/* [U[`ɃANZX */
	access_user_dic( entry, word, filename, acc_flg );
	
	/* ֐ */
	remove_function( buf );
	
	/* ̈J */
	if( GAiDic != NULL ) free( GAiDic_HGL );
	if( GAiDArea != NULL ) free( GAiDArea_HGL );
	for( loop_cnt = 0; loop_cnt < PL_DIC_NUM; loop_cnt++ ){
		if( GPlAiDic[loop_cnt] != NULL ) free( GPlAiDic[loop_cnt] );
		if( GPlAiDArea[loop_cnt] != NULL ) free( GPlAiDArea[loop_cnt] );
	}
	
	/* ʏGge[uJ */
	if( GEntryList != NULL )free( GEntryList );
	if( GEntryListString != NULL )free( GEntryListString );
	
	/* t@Cǂݒ */
	read_dic();
	
	return(0);
	
}


/************************************************************************/
/*				[U[ւ̃ANZXiE폜j					*/
/************************************************************************/
int access_user_dic( char* entry, char* word, char* filename, int acc_flg )
{
	char tmp_file[1030];
	char wrk[2048];
	char* p_wrk;
	char* line;
	unsigned long wrkl;
	
	strcpy( tmp_file, GlobalPath );
	strcat( tmp_file, "eseai_user.^_^" );
	
	/* [U[t@C̗L擾 */
	if( access( filename, 0 ) != 0 ){
		/* wt@C݂Ȃ̂ŐVK쐬 */
		FILE* fp_write = fopen( filename, "wt" );
		if( fp_write == NULL ){
			return(1);
		}
		fprintf( fp_write, "/////////////////////////////////////////////////////////////////////////////\n", wrk );
		fprintf( fp_write, "//\n", wrk );
		fprintf( fp_write, "//	eseshiori dic file\n", wrk );
		fprintf( fp_write, "//\n", wrk );
		fprintf( fp_write, "/////////////////////////////////////////////////////////////////////////////\n", wrk );
		fprintf( fp_write, "\n", wrk );
		fclose( fp_write );
		
	}
	
	FILE* fp_read = fopen( filename, "rt" );
	if( fp_read == NULL )return(1);
	
	FILE* fp_write = fopen( tmp_file, "wt" );
	if( fp_write == NULL ){
		fclose(fp_read);
		return(1);
	}
	
	int entry_flg = 0;
	int set_flg = 0;
	while( fgets( wrk, 2040, fp_read ) != NULL ){
		/* sAdneR[h */
		p_wrk = strchr( wrk, 0x0d );
		if( p_wrk != NULL )*p_wrk = '\0';
		p_wrk = strchr( wrk, 0x0a );
		if( p_wrk != NULL )*p_wrk = '\0';
		p_wrk = strchr( wrk, 0x1a );
		if( p_wrk != NULL )*p_wrk = '\0';
		
		/* Ggs̏ */
		if( wrk[0] == '#' && entry_flg >= 0 ){
			if( memlcmp( &wrk[1], entry ) == 0 )entry_flg = 1;
			else								entry_flg = 0;
		}
		
		/* [hŊYGgǋL */
		if( entry_flg == 1 && acc_flg == USER_DIC_SET ){
			fprintf( fp_write, "%s\n", wrk );
			fprintf( fp_write, "%s\n", word );
			entry_flg = -1;
			set_flg = 1;
			continue;
		}
		
		/* op[^ǂݔ΂ */
		if( sscanf( wrk, "%ld,", &wrkl ) == 1 &&
			( p_wrk = strchr(wrk,',') ) != NULL ){
			/* LqĂ̂ł̋Lq΂ĕAhXZbg */
			line = p_wrk+1;
		}
		else{
			/* AhXZbg */
			line = wrk;
		}
		
		/* 폜[hŎwGgwPꂪ */
		if( entry_flg == 1 && acc_flg == USER_DIC_DEL ){
			if( strcmp( line, word ) == 0 ){
				entry_flg = -1;
				continue;
			}
		}
		
		/* Ggw肳Ă炸AwPꂾ */
		if( *entry == '\0' ){
			if( strcmp( line, word ) == 0 ){
				entry_flg = -1;
				continue;
			}
		}
		
		/* ǂ̏ɂ|Ȃ̂ŏȂ */
		fprintf( fp_write, "%s\n", wrk );
		
	}
	
	/* [hŎwGgꍇi܂ǋLĂȂjAVK */
	if( set_flg == 0 && acc_flg == USER_DIC_SET && *entry != '\0' ){
		fprintf( fp_write, "#%s\n%s\n\n", entry, word );
	}
	
	/* t@C */
	fclose(fp_write);
	fclose(fp_read);
	
	/* t@C폜Ĉꎞt@CVt@CƂăl[ */
	unlink( filename );
	rename( tmp_file, filename );
	
	return(0);
	
}


/************************************************************************/
/*				ƃCxgs֐								*/
/************************************************************************/
int self_event( char* buf )
{
	
	char send_str[1024];
	char wrk[1024];
	char wrk2[1024];
	char wrk3[128];
	char* p_wrk = buf;
	int loop_cnt;
	
	/* ő吔zĂ珈Ȃ */
	if( GSelfEventNum >= SELF_EVENT_MAX ){
		remove_function( buf );
		return(1);
	}
	
	while( *p_wrk != '(' )p_wrk++;
	p_wrk++;
	
	/* P擾 */
	get_comma_lenword( p_wrk, wrk, 0, 1020 );
	delete_doublequotation( wrk );
	
	/* Q擾 */
	get_comma_lenword( p_wrk, wrk2, 1, 1020 );
	
	/* {`iOj쐬 */
	strcpy( send_str, "NOTIFY SSTP/1.0\r\n" );
	strcat( send_str, "Sender: ESESHIORI\r\n" );
	strcat( send_str, "Event: " );
	strcat( send_str, wrk );
	strcat( send_str, "\r\n" );
	
	/* Rȍ~擾iReference7܂Łj */
	for( loop_cnt = 0; loop_cnt < 8; loop_cnt++ ){
		get_comma_lenword( p_wrk, wrk, 2 + loop_cnt, 1020 );
		delete_doublequotation( wrk );
		if( wrk[0] != '\0' ){
			sprintf(wrk3, "Reference%d: ", loop_cnt );
			strcat( send_str, wrk3 );
			strcat( send_str, wrk );
			strcat( send_str, "\r\n" );
		}
	}
	
	/* {`i㔼j쐬 */
	sprintf( wrk, "HWnd: %d\r\n", GHWnd );
	strcat( send_str, wrk );
	strcat( send_str, "Charset: " ); 
	strcat( send_str, GStrDicCode ); 
	strcat( send_str, "\r\n\r\n" ); 
	
	/* f[^GAɃZbg */
	p_wrk = (char*)malloc( strlen(send_str) );
	if( p_wrk != NULL ){
		strcpy( p_wrk, send_str );
		GSelfEvent[GSelfEventNum].send_string = p_wrk;
		GSelfEvent[GSelfEventNum].timer = atoi( wrk2 );
		GSelfEventNum++;
	}
	
	/* ֐ */
	remove_function( buf );
	
	return(0);
	
}


/************************************************************************/
/*				$func( "???", x, y )`֐̈擾					*/
/************************************************************************/
int getarg_str_num_num(char* buf, char* get_buf, int* arg2, int* arg3)
{
	
	char wrk[2048];
	char* p_wrk;
	char* p_wrk2;
	
	/* 񕔕擾 */
	p_wrk = strchr( buf, '\"' );
	if( p_wrk == NULL )return(1);		/* ""ŊĂȂ̂ŃG[ */
	memcpy( wrk, p_wrk+1, 2048 );
	p_wrk = strchr( wrk, '\"' );
	if( p_wrk == NULL )return(1);		/* ""ŊĂȂ̂ŃG[ */
	*p_wrk = '\0';
	strncpy( get_buf, wrk, 1020 );
	*(get_buf+1020) = '\0';
	
	/* QAR擾iȗꂽꍇ͓ǂ܂Ȃj */
	p_wrk2 = strchr( p_wrk+1, ')' );
	if( p_wrk2 == NULL )return(1);		/* ʕ̂͂ */
	*p_wrk2 = '\0';						/* ʕ𕶎I[ɂ */
	
	/* Q̗L */
	p_wrk2 = strchr( p_wrk+1, ',' );
	if( p_wrk2 == NULL ){
		/* ȗĂ̂ŉǂ܂ɐI */
		return(0);
	}
	else{
		/* Q擾 */
		sscanf( p_wrk2+1, "%d", arg2 );
		
		/* R̗L */
		p_wrk = strchr( p_wrk2+1, ',' );
		if( p_wrk != NULL ){
			/* R擾 */
			sscanf( p_wrk+1, "%d", arg3 );
		}
	}
	return(0);
}

/************************************************************************/
/*				 " , x , y )"̈擾							*/
/************************************************************************/
int get_last2arg(char* buf, int* arg1, int* arg2)
{
	
	char wrk[1024];
	char* p_wrk;
	char* p_wrk2;
	
	memcpy( wrk, buf, 1024 );
	p_wrk2 = strchr( wrk, ')' );
	if( p_wrk2 == NULL )return(1);		/* ʕ̂͂ */
	*p_wrk2 = '\0';						/* ʕ𕶎I[ɂ */
	
	/* LAST2̗L */
	p_wrk2 = strchr( wrk, ',' );
	if( p_wrk2 == NULL ){
		/* ȗĂ̂ŉǂ܂ɐI */
		return(0);
	}
	else{
		/* LAST2擾 */
		sscanf( p_wrk2+1, "%d", arg1 );
		
		/* LAST1̗L */
		p_wrk = strchr( p_wrk2+1, ',' );
		if( p_wrk != NULL ){
			/* LAST1擾 */
			sscanf( p_wrk+1, "%d", arg2 );
		}
	}
	return(0);
}

/************************************************************************/
/*				X^bNiu܂ށj						*/
/************************************************************************/
int set_stack(char* buf, char* get_str, int stack_no, int mode)
{
	
	/* X^bNꏊ̒ */
	if( stack_no > PUSH_NUM )stack_no = 0;
	else					stack_no--;		/* ł0` */
	
	/* m */
	if( stack_no >= 0 ){
		free_target_paragraph( stack_no );
		if( *get_str == '\0' ){
			/* OoCg̒̎̓mۂȂ */
		}
		else if( ( GStack[stack_no] = (char*)malloc( strlen(get_str)+1 )) != NULL ){
			/* eRs[ */
			strcpy( GStack[stack_no], get_str );
		}
		else{
			/* mێs */
			GStack[stack_no] = NULL;
			return(1);
		}
	}

	/* LeccȂ */
	if( mode == PARAGRAPH_INVISIBLE ){
		/* cȂi폜j */
		remove_function(buf);
	}
	else{
		/* c */
		remove_function( buf );
		strmov( buf, buf+strlen(get_str) );
		memcpy( buf, get_str, strlen(get_str) );
	}

	return(0);
}


/************************************************************************/
/*				t@NV{폜						*/
/************************************************************************/
int remove_function(char* buf)
{
	
	char* p_wrk;
	int flg = 0;
	int loop_cnt;
	int len = strlen(buf);
	
	/* ۊʏI[T */
	for( loop_cnt = 0; loop_cnt < len; loop_cnt++ ){
		if( *(buf+loop_cnt) == '\"' )flg = !flg;
		if( *(buf+loop_cnt) == ')' && flg == 0 )break;
	}
	
	if( loop_cnt != len ){
		/* ۊʏI[̕bufɏ㏑ */
		p_wrk = buf+loop_cnt+1;
		len = strlen( p_wrk )+1;
		
		for( loop_cnt = 0; loop_cnt < len; loop_cnt++ ){
			*(buf+loop_cnt) = *(p_wrk+loop_cnt);
		}
	}
	else{
		/* ۊʏI[tȂ̂bufɕI[Zbg */
		*buf = '\0';
	}
	
	return(0);
	

}


